#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include "debug.h"
#include "../headers_c/newpluginapi.h"
#include "../headers_c/m_database.h"

extern PLUGININFO pluginInfo;
static FILE *fpLog = NULL, *fpDbgLog = NULL;

void log_write(char *prfx, ...) {
	DBVARIANT dbv;
	time_t lt;
	static char szLog[MAX_PATH]={0};
	char *ct, s[MAX_LOG_LINE];
	va_list ap;

	if (!DBGetContactSettingByte(NULL, pluginInfo.shortName, "DoLog", 0)) return;
	if (!fpLog)
	{
		if (!*szLog)
		{
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "Logfile", &dbv)) {
				strncpy(szLog, dbv.pszVal, sizeof(szLog));
				DBFreeVariant(&dbv);
			} else strcpy(szLog, "sms_log.txt");
		}

		if (!(fpLog=fopen(szLog, "a")))
			return;
	}
	
	time(&lt);
	ct=ctime(&lt);
	ct[strlen(ct)-1]=0;

	_snprintf(s, MAX_LOG_LINE, "%s    ", ct);
	for (ct = s; *ct != '\0'; ct++);

	va_start(ap, prfx);
	_vsnprintf(ct, MAX_LOG_LINE-(ct - s), prfx, ap);
	va_end(ap);

	fprintf(fpLog, "%s", s);
}

void log_close(void)
{
	if (fpLog) fclose (fpLog);
	fpLog=NULL;
#ifdef DEBUG_OUT
	if (fpDbgLog) fclose (fpDbgLog);
	fpDbgLog = NULL;
#endif
}

#ifdef DEBUG_OUT
void debug_log_write(char *prfx, ...) {
	DBVARIANT dbv;
	static char szLog[MAX_PATH]={0};
	va_list ap;

	if (!DBGetContactSettingByte(NULL, pluginInfo.shortName, "DoLog", 0)) return;
	if (!fpDbgLog)
	{
		if (!*szLog)
		{
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "Logfile", &dbv)) {
				strncpy(szLog, dbv.pszVal, sizeof(szLog));
				DBFreeVariant(&dbv);
			} else strcpy(szLog, "sms_log.txt");
		}

		if (!(fpDbgLog=fopen(szLog, "a")))
			return;
	}

	va_start(ap, prfx);
	vfprintf (fpDbgLog, prfx, ap);
	va_end(ap);
}
#endif
