/*
 History: 0.0.0.2 - Fixed Rescan-Button (ooops.. :)
				  - Removed accept-encoding gzip (causing crashes) (/me idiot ;)
				  - Added Editme= config file option.
		  0.0.0.3 - Fixed a lockup when a required cookie wasn't found
				  - Fixed a crash when parsing the URL failed
				  - Now replacing relative Dirs .\Gateways with absolute path
				  - Moved Options dialog to "Plugins"
				  - Now status if active or not is remembered on next start
				  - Added support for MapPrefix=
				  - Fixed a memory leak involving HTTP 302 redirects
				  - Now window position is saved
				  - Now last selected prefix and entered numbers are saved
				  - Added RequiresVersion function
				  - Wrote a little tutorial on how to generate .ini files yourself
				  - Finally included the .sac file I forgot last time
				  Thx to lex for helping me with the beta tests :)
				  Thx to Igor for his suggestions
		  0.0.0.4 - HOTFIX: Fixed a crash that occured at the end of a request
					when freeing Cookies
		  0.0.0.5 - BUGFIX: Now CustomVars are URLencoded internally
				  - BUGFIX: Fixed a memory allocation bug in the Cookie manager
				  - BUGFIX: Now Cookies in 302 Redirects are grabbed too
				  - BUGFIX: Fixed Progressbar
				  - Added WinINET-Support (compile-time option)
				    With WinINET HTTPS-transactions are possible now!
					But you still have the chance to use NETLIB instead of WinInet
		  0.0.0.6 - BUGFIX: Servers which didn't return Content-Length didn't work
							with WinInet-functions (nearly all GWs I implemented, ooops)
				  - BUGFIX: URLencoding of Custom variables ie. broke Compatibility
							with cineplexx.at Gateway. Now only POSTdata is URLencoded.
				  - HTTP 303-Redirects are now handled (like 302).
				  - BUGFIX: Fixed error with multiple cookies in 302 redirect
				  - BUGFIX: Fixed a memory leak with last redirect URL
				  - BUGFIX: Now Cookies are processed after a 302 redirect again
				            (broke compatibility with t-online and cineplexx)
		  0.0.0.7 - BUGFIX: It seems that HTTP Results were not completely retrieved
							sometimes with WinINET. This should be fixed by now.
				  - BUGFIX: Enhanced buffer for Poststrings from 256 to 2048 bytes.
				  - Added feature to use only parts of a String from a variable
				    (see t-online.ini for documentation)
		  0.0.0.8 - BUGFIX: 301 - Moved permanently is now handled too
					BUGFIX: If host-portion of a URL contains a Port-Number this is now
					        detected, in WININET-version at least (don't know how netlib
							handles it)
		  0.0.0.9 - Now capable of UNICODE SMS-messages
		          - Dialogs now translatable
				  - Sending via CRTL + Return works now.
				  - Added a nice address book function for more convenient use.
				    It even supports the Windows Address Book to import phone numbers! :)
				    IMPORTANT: If a phone number belongs to a contact on your contact list,
					add it the standard-way by selecting the contact's properties and
					insert the number there! (Don't forget to activate the SMS checkbox)
					Only add a phonebook-entry via the Address-book if it doesn't match
					an existing contact!!
					IMPORTANT2: Please correct your .ini files so that the Prefix= lines
					really show the correct Dial-prefix rather than 1, 2 or 3..
					If your gateway uses distinction via such numbers, use MapPrefix!
					Otherwise we will end up in a big mess because of inavlid prefixes...
				    NOTE: Programmes who want to use the address book contacts,  ie. to
					make a protocol that supports SMS-sending via IM-dialogs, please note
					that all phonebook-entries are normal contacts that belong to the
					protocol named "HTTP_SMS". 
					So if you want to implement this: 
					1) Give your custom protocol that name.
					2) Unhide all your contacts (they are set to hidden per default)
					3) On message sending, call the service "SendSMS/MenuCommand" with
					   wParam = hContact and lParam = (char*)szMessage
				  - Added the long-awaited feature to sort the Gateway priority yourself.
				  - BUGFIX: Selection of Provider-Prefix on sending SMS to a specific contact
				            via rightclick was faulty.
				  - BUGFIX: Now "Send WebSMS" context menu is only shown for a contact that
				            has a valid Dial-Prefix in its user-info that is supported by
							the Gateways currently loaded.
				  - CHANGE: Now the WebSMS - Options dialog is an extra item in the config Dlg.
		0.0.0.10  - BUGFIX: Crash of Address book dialog with empty Windows Abook fixed.
		          - Added feature UseSelectData - If set, PostData in <select> fields from 
				    this page is extracted automatically and added to every POST.
		0.0.0.11  - BUGFIX: WinInetGet now fails if InternetReadFile fails instead of being stuck in
					an infinite loop.
		0.0.0.12  - Added functions for new Miranda plugin API.
		0.0.0.13  - BUGFIX: Now maximum number of redirects in a row to prevent redirection
							infinite loops.
					BUGFIX: When there was no body in a message, the WINinet-Build didn't
							read the headers.
*/

#include "main.h"
#include "debug.h"

// Plugin Info
#define PINFO \
	"WebSMS-Plugin", \
	PLUGIN_MAKE_VERSION(0,0,0,13), \
	"Support for sending SMS-Messages via HTTP SMS-Providers", \
	"leecher", \
	"leecher@dose.0wnz.at", \
	" 2004 leecher", \
	"http://dose.0wnz.at", \
	0,	\
	0		//doesn't replace anything built-in


PLUGININFO pluginInfo = {
	sizeof(PLUGININFO),
	PINFO
};

// New plugininfo (Breaking the API, what were they thinking..?)
// Why a new struct and not just incorporate the additional parameters
// into the old struct and only change the size parameter? What elso would the sizeof parameter be good for,
// if not for versioning?
PLUGININFOEX pluginInfoEx = {
	sizeof (pluginInfoEx),
	PINFO,
	{ 0x4a86006d, 0x503c, 0x42e2, { 0x8f, 0x21, 0x1b, 0x4c, 0xf9, 0x7f, 0x14, 0x97 } }	// {4A86006D-503C-42e2-8F21-1B4CF97F1497}
};

// Whatever this is...
// {32125DF1-4933-4340-B80C-372ACE0825DA}
#define MIID_WEBSMS { 0x32125df1, 0x4933, 0x4340, { 0xb8, 0xc, 0x37, 0x2a, 0xce, 0x8, 0x25, 0xda } }

#define MAX_REDIRECTS 5

static const MUUID interfaces[] = { MIID_WEBSMS, MIID_LAST };

const char *pszGWOrderfile = "gateways.ord";
char *pszModulename="HTTP_SMS", errsend[512], GatewayPath[MAX_PATH];
int numCookies=0;
HINSTANCE hInst;
HANDLE hNetlibUser=NULL, hHookModulesLoaded, hOptHook, hStatusModeHook, hMenuItemSMS, hPrebuildCMenu;
PLUGINLINK *pluginLink;
NETLIBHTTPHEADER CookieJar[MAXCOOKIES];
BOOL AbortSending=FALSE, Activated=FALSE, UseWinInet=TRUE;
SENDTPARAM stpar={0};

static BOOL CALLBACK SendDlgProc(HWND,UINT,WPARAM,LPARAM);
static BOOL CALLBACK OptionsDlgProc(HWND,UINT,WPARAM,LPARAM);
static BOOL CALLBACK OptionsGWListDlgProc(HWND,UINT,WPARAM,LPARAM);
static int SMSMenuCommand(WPARAM,LPARAM);
static int SendMenuCommand(WPARAM,LPARAM);
static WNDPROC SendDlgEditProc, GWListDlgEditProc;
int ShowMessage(int, char *, int);

/*******************************************************************************/



/*******************************************************************************
  Miranda-Bugfixing 
  Miranda uses signed char insted of unsigned, so umlauts etc. don't work
*/

static char szHexDigits[]="0123456789ABCDEF";
int _NetlibHttpUrlEncode(WPARAM wParam,LPARAM lParam)
{
	unsigned char *szOutput,*szInput=(char*)lParam;
	unsigned char *pszIn,*pszOut;
	int outputLen;

DEBUG_OUT("_NetlibHttpUrlEncode(*ptr, %s) called...", szInput);

	if(szInput==NULL) {
		SetLastError(ERROR_INVALID_PARAMETER);
DEBUG_OUT("FAILED.\n");
		return (int)(char*)NULL;
	}
	for(outputLen=0,pszIn=szInput;*pszIn;pszIn++) {
		if(isalnum(*pszIn) || *pszIn==' ') outputLen++;
		else outputLen+=3;
	}
	szOutput=(char*)HeapAlloc(GetProcessHeap(),0,outputLen+1);
	if(szOutput==NULL) {
		SetLastError(ERROR_OUTOFMEMORY);
DEBUG_OUT("FAILED.\n");
		return (int)(char*)NULL;
	}
	for(pszOut=szOutput,pszIn=szInput;*pszIn;pszIn++) {
		if(isalnum(*pszIn)) *pszOut++=*pszIn;
		else if(*pszIn==' ') *pszOut++='+';
		else {
			*pszOut++='%';
			*pszOut++=szHexDigits[*pszIn>>4];
			*pszOut++=szHexDigits[*pszIn&0xF];
		}
	}
	*pszOut='\0';
DEBUG_OUT("OK: %s\n", szOutput);
	return (int)szOutput;
}


/*******************************************************************************/
struct GWLIST *Gateways=NULL; 
char* Prefixes[256];

/* ListInit
 * 
 * Purpose: Initializes the Gateway list queue
 * Returns: 0 - Success
 *         -1 - Memory allocation failure
 */
int ListInit(void) {
DEBUG_OUT("Initilaizing linked list...");	
	if ((Gateways=(struct GWLIST*)malloc(sizeof(struct GWLIST)))==NULL) return -1;
	Gateways->next=NULL;
	memset (Prefixes, 0, sizeof(Prefixes));
DEBUG_OUT("OK.\n");
	return 0;
}

/* ListAdd
 * 
 * Purpose: Add Entry to linked list
 * Params : filen - Filename of the inifile
 * Returns: 0 - Success
 *         -1 - Memory allocation failure
 */
int ListAdd(char *filen, BOOL bEnable) {
	struct GWLIST *ptr;
	char *inifile;
	int i;

DEBUG_OUT("Adding entry %s to linked list...", filen);
	ptr=Gateways;
	if (!ptr) FAILURE
	while (ptr->next!=NULL) ptr=ptr->next;
	if ((ptr->next=(struct GWLIST*)malloc(sizeof(struct GWLIST)))==NULL) FAILURE
	ptr=ptr->next;
	// Don't forget to free() values on cleanup
	if (!(inifile=(char *)malloc(strlen(GatewayPath)+strlen(filen)+2))) FAILURE
	strcpy(inifile, GatewayPath);
	strcat(inifile, "\\");
	strcat(inifile, filen);
	ptr->fullpath=inifile;
	ptr->filename=strdup(filen);
	ptr->bEnabled=bEnable;
	ptr->next=NULL;
	// Now we also add the Prefixes contained in this file to our Prefixes-list
	for (i=1;i<256;i++) {
		int j;
		char *pos, Prefix[10], buf[256];
		BOOL bFound = FALSE;

		sprintf(Prefix, "Prefix%d", i);
		if (!GetPrivateProfileString("Gateway", Prefix, "", buf, sizeof(buf), ptr->fullpath)) break;
		if (!(pos=strchr(buf, ';'))) {
			_snprintf(buf, sizeof(buf), "Error: No ; seperator in Prefix #%d in Gateway file %s", i, ptr->filename);
			SHOWERROR(buf);
			break;
		}
		pos[0]=0;
		// Check for dupe
	    for (j=0; Prefixes[j] && j<256; j++) {
			if (!strcmp (Prefixes[j], buf)) {
				bFound = TRUE;
				break;
			}
		}
		if (bFound || j==255) continue;
		pos[0]=';';
		Prefixes[j]=_strdup(buf);
		(*strchr(Prefixes[j], ';'))=0;
	}
	DEBUG_OUT("OK\n");
	return 0;
}

/* ListCleanup
 * 
 * Purpose: Clean up the whole List - free() all
 */
void ListCleanup(void) {
	struct GWLIST *ptr;
	int i=0;

	DEBUG_OUT("Cleaning up linked list...");
	if (Gateways) Gateways->filename=Gateways->fullpath=NULL;
	while (Gateways) {
		ptr=Gateways;
		if (ptr->filename) free(ptr->filename);
		if (ptr->fullpath) free(ptr->fullpath);
		Gateways=ptr->next;
		free(ptr);
	}
	while (Prefixes[i]) {
		free (Prefixes[i]);
		Prefixes[i]=NULL;
		i++;
	}
	DEBUG_OUT("OK.\n");
}

/* ListSize
 *
 * Purpose: Get the number of elements in the linked list
 */
int ListSize(void) {
	struct GWLIST *ptr;
	int i=0;

	DEBUG_OUT("Getting size of linked list...");
	ptr=Gateways->next;
	while(ptr) {
		i++;
		ptr=ptr->next;
	}
	DEBUG_OUT("OK, %d entries\n", i);
	return i;
}


/* ListRotate
 *
 * Purpose: Rotates the list, move first entry to the last place
 * Returns:  0 - Success
 *			-1 - Nothing to rotate, list too small
 */
int ListRotate(void) {
	struct GWLIST *ptr, *ptr2;

	DEBUG_OUT("Rotating linked list...");
	if (!Gateways->next || !(ptr2=Gateways->next->next)) FAILURE
	ptr=Gateways;
	while (ptr->next) ptr=ptr->next;
	ptr->next=Gateways->next;
	Gateways->next->next=NULL;
	Gateways->next=ptr2;
	DEBUG_OUT("OK.\n");
	return 0;
}

struct GWLIST *ListFind (char *pszFile, struct GWLIST **referrer)
{
	struct GWLIST *ptr = Gateways;

	do {
		*referrer = ptr;
		ptr=ptr->next;
		if (!ptr) break;
		if (!strcmp (ptr->filename, pszFile)) {
			return ptr;
		}
	} while (ptr);
	return NULL;
}


/*******************************************************************************/

int ScanGatewayList(void) {
	struct _finddata_t ini_file;
	char *findexpr, buf[256];
	long hFile;
	struct _stat filestat;
			
	DEBUG_OUT("ScanGatewayList() - start\n");
	if (!(findexpr=(char *)malloc(strlen(GatewayPath)+7))) return -1;
	if (_stat(GatewayPath, &filestat)) {
		MessageBox(NULL, Translate("Huston, we got a problem.. The specified gateway-path was not found. Please give me the correct path in the options dialog"), pluginInfo.shortName, MB_OK | MB_ICONWARNING);
		DEBUG_OUT("ScanGatewayList() - FAILED.\n");
		return 0;
	}
	
	strcpy(findexpr, GatewayPath);
	strcat(findexpr, "\\*.ini");
	hFile = _findfirst(findexpr, &ini_file);
	free(findexpr);
	if (!hFile) MessageBox(NULL,Translate("No Gateway Configfiles found in specified path. Check options"),pluginInfo.shortName, MB_OK | MB_ICONWARNING);

	do {
		char *inifullp;
		if (!(inifullp=(char *)malloc(strlen(ini_file.name)+strlen(GatewayPath)+2))) return -1;
		strcpy(inifullp, GatewayPath);
		strcat(inifullp, "\\");
		strcat(inifullp, ini_file.name);

		if (GetPrivateProfileString("Gateway", "RequiresVersion", "", buf, sizeof(buf), inifullp)) {
			DWORD version=0;
			int i;
			char *p, *p2;

			DEBUG_OUT("There is a RequiresVersion tag in this gateway config. Checking...\n");
			if (strlen(buf)<7) {
				DEBUG_OUT("RequiresVersion tag too short.\n");
verserr:
				_snprintf(buf, sizeof(buf), Translate("Warning: The specified Gateway %s has no correct versioning info. It is ignored. Please fix the RequiresVersion entry in the .ini file."), ini_file.name);
				MessageBox(NULL,buf,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
				continue;
			}
			p=buf;
			for(i=3;i>-1;i--) {
				int j=i*8;
				if (!p) goto verserr;
				if (p2=strchr(p, '.')) p2[0]=0; else if (i>0) goto verserr;
				version|=((((DWORD)(atoi(p)))&0xFF)<<j);
				if (i>0) p=p2+1;
			}
			DEBUG_OUT("  Required version: %d ; Our version: %d\n", version, pluginInfo.version);
			if (version>pluginInfo.version) {
				_snprintf(buf, sizeof(buf), Translate("Warning: The specified Gateway %s is designed for a newer version of the plugin. It is ignored. Please download the newest plugin version from www.miranda-im.org\n"), ini_file.name);
				OUTPUT(buf);
				MessageBox(NULL,buf,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
				continue;
			}
		}
		free(inifullp);
		if (ListAdd(ini_file.name, TRUE)==-1) return -1;
	} while (_findnext(hFile, &ini_file )==0);
	
	{
		char szListFile[MAX_PATH];
		FILE *pFile;
		struct GWLIST *FIRST = Gateways;

		_snprintf (szListFile, sizeof(szListFile), "%s\\%s", GatewayPath, pszGWOrderfile);
		if (pFile=fopen(szListFile, "r"))
		{
			struct GWLIST *ptr, *ptr2, *referrer, *lastptr = Gateways;

			DEBUG_OUT("ScanGatewayList() - Sorting according to listfile");
			while (fgets (szListFile, sizeof(szListFile), pFile))
			{
				szListFile[strlen(szListFile)-1]=0;
				if ((ptr = ListFind (szListFile+2, &referrer)) && ptr != lastptr)
				{
					referrer->next = ptr->next;
					ptr2 = lastptr->next;
					lastptr->next = ptr;
					ptr->bEnabled = szListFile[0];
					ptr->next = ptr2;
					lastptr = ptr;
				}
			}
			fclose (pFile);
		}
	}
	DEBUG_OUT("ScanGatewayList() - OK.\n");
	return 0;
}

void SubstitutePath(char *path) {
	if (path && strlen(path)>2 && path[0]=='.' && path[1]=='\\') {
		char *p, NewPath[MAX_PATH];
		
		DEBUG_OUT("We need to substitute a relative path (%s)...", path);
		if (GetModuleFileName(NULL, NewPath, sizeof(NewPath)))
		{
			p=NewPath+strlen(NewPath);
			while (*p!='\\' && p>NewPath) p--;
			if (p>NewPath) {
				p[0]=0;
				strncat(NewPath, path+1, sizeof(NewPath));
				strcpy(path, NewPath);
			}
		}
		DEBUG_OUT("OK, new path: %s\n", path);
	}
}

/*
 * RegisterOptions
 *
 * This function tells Miranda to add the configuration section of this plugin in
 * the Options-dialog.
 */
int RegisterOptions(WPARAM wParam, LPARAM lParam) {
   OPTIONSDIALOGPAGE odp;
   
   DEBUG_OUT("Registering options dialog page...");
   ZeroMemory(&odp, sizeof(odp));
   odp.cbSize = sizeof(odp);
   odp.hInstance = hInst;
   odp.pszTemplate = MAKEINTRESOURCE(IDD_OPTIONS);
   odp.pszTitle = pluginInfo.shortName;
   odp.pfnDlgProc = OptionsDlgProc;
   CallService(MS_OPT_ADDPAGE, wParam, (LPARAM)&odp);
   odp.pszGroup = pluginInfo.shortName;
   odp.pszTitle = Translate ("Gateway order");
   odp.pszTemplate = MAKEINTRESOURCE(IDD_OPTIONS_GWORDER);
   odp.pfnDlgProc = OptionsGWListDlgProc;
   CallService(MS_OPT_ADDPAGE, wParam, (LPARAM)&odp);
   DEBUG_OUT("OK.\n");
   return 0;
}


int ReceivedMessage(WPARAM wParam,LPARAM lParam) {
    CCSDATA *pccsd = (CCSDATA *)lParam;
    PROTORECVEVENT *ppre = (PROTORECVEVENT *)pccsd->lParam;
	DBVARIANT dbv, dbv_sender;
	char *trigger, *p;

DEBUG_OUT("I received a message ('%s' from hContact %d), parsing...", ppre->szMessage, pccsd->hContact);
	if (!Activated || DBGetContactSetting(NULL, pluginInfo.shortName, "SenderNumber", &dbv_sender) ||
		!(p=strchr(dbv_sender.pszVal, ' '))) {
			DEBUG_OUT("Nothing to do for me.\n");
			return CallService(MS_PROTO_CHAINRECV, wParam, lParam);
	}
	p[0]=0;
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "Trigger", &dbv)) {
		if (!dbv.pszVal) {
			DBFreeVariant(&dbv);
			DBFreeVariant(&dbv_sender);
			DEBUG_OUT("No trigger found.\n");
			return CallService(MS_PROTO_CHAINRECV, wParam, lParam);
		}
		trigger=strdup(dbv.pszVal);
		DBFreeVariant(&dbv);
	} else trigger=strdup("[SMS]");
	if (!strncmp(trigger, ppre->szMessage, strlen(trigger))) {
		SENDWPARAM swpar={0};
		SMSDATA sms={0};
		char *msg, *nick;
		time_t llast=0, ltime;

		DEBUG_OUT("Trigger found!\n");
		time(&ltime);
		if ((llast=DBGetContactSettingDword(pccsd->hContact, pluginInfo.shortName, "LastSendTime", 0)) &&
			(unsigned int)(ltime-llast)<((unsigned int)DBGetContactSettingWord(NULL, pluginInfo.shortName, "UserMsgInterval", 5)*60)) {
			char buf[1024];
			
			// As I'm lazy, I use a static buffer for the reply, as I don't want to make a hook on
			// protocol ACK and then free() the allocated mem...
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FloodMsg", &dbv)) {
				_snprintf(buf, sizeof(buf), dbv.pszVal, ((DBGetContactSettingWord(NULL, pluginInfo.shortName, "UserMsgInterval", 5)*60)-(ltime-llast))/60);
				OUTPUT("User tried to flood the gateway. I said to him: %s\n", buf);
				CallContactService(pccsd->hContact,PSS_MESSAGE,0,(LPARAM)buf);
				DBFreeVariant(&dbv);
			}
		} else {
			DEBUG_OUT("User is allowed to send a message.\n");
			sms.prefix=dbv_sender.pszVal;
			sms.number=p+1;
			swpar.hContact=pccsd->hContact;
			nick=(char*)CallService(MS_CLIST_GETCONTACTDISPLAYNAME, (WPARAM)pccsd->hContact, 0);
			if (msg=(char *)malloc(strlen(ppre->szMessage)+strlen(nick)+7)) {
				strcpy(msg, "(ICQ)");
				strcat(msg, nick);
				strcat(msg, ":");
				strcat(msg, ppre->szMessage+strlen(trigger));
				sms.szMsg=msg;
				swpar.sms=&sms;
				OUTPUT("User %s wants to send a message: %s\n", nick, msg);
				DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_SMSDLG),NULL,SendDlgProc,(LPARAM)&swpar);
				// Even if sending fails, we don't want the user to flood the gateway
				time(&ltime);
				DBWriteContactSettingDword(pccsd->hContact, pluginInfo.shortName, "LastSendTime", ltime);
				free(msg);
			}
		}
	} else {
//		CallContactService(pccsd->hContact,PSS_MESSAGE,0,(LPARAM)"I'm the Autoresponder ");
	}
	free(trigger);
	DBFreeVariant(&dbv_sender);
	DEBUG_OUT("Message parsing completed.\n");
	return CallService(MS_PROTO_CHAINRECV, wParam, lParam);
}

int StatusModeChange(WPARAM wParam,LPARAM lParam) {
	if (!DBGetContactSettingByte(NULL, pluginInfo.shortName, "ActivateOnNA", 0)) return 0;
	if (wParam==ID_STATUS_NA) Activated=TRUE; else Activated=FALSE;
	return 0;
}

/*
 * AccountsRotate
 *
 * Rotates Account-list so that Account #num is moved to top
 *
 * Returns:  0 - Success
 *			-1 - Failure (fname may be in a inconsistant state!)
 */
int AccountsRotate(char *fname, int num) {
	int i, j, c=1;
	char buf[256], SectName[12], NewSectName[12];

	DEBUG_OUT("Called Accountsrotate(%s, %d)...", fname, num);
	// Check if num/fname is valid
	sprintf(SectName, "Account%d", num);
	if (!GetPrivateProfileString(SectName, "Username", "", buf, sizeof(buf), fname)) FAILURE

	// Copy Accounts to Temp-section
	for (i=1;i<256;i++) {
		sprintf(SectName, "Account%d", i);
		if (!GetPrivateProfileString(SectName, "Username", "", buf, sizeof(buf), fname)) break;
		sprintf(NewSectName, "Temp%d", i);
		if (WritePrivateProfileString(NewSectName, "Username", buf, fname)==FALSE) FAILURE
		if (GetPrivateProfileString(SectName, "Password", "", buf, sizeof(buf), fname))
			if (WritePrivateProfileString(NewSectName, "Password", buf, fname)==FALSE) FAILURE
	}
	// Now rotate it deleting the temp-sections
	for (j=0;j<2;j++) {
		for (i=num;i<256;i++) {
			sprintf(SectName, "Temp%d", i);
			sprintf(NewSectName, "Account%d", c);
			if (!GetPrivateProfileString(SectName, "Username", "", buf, sizeof(buf), fname)) break;
			if (WritePrivateProfileString(NewSectName, "Username", buf, fname)==FALSE) FAILURE
			if (GetPrivateProfileString(SectName, "Password", "", buf, sizeof(buf), fname))
				if (WritePrivateProfileString(NewSectName, "Password", buf, fname)==FALSE) FAILURE
			WritePrivateProfileString(SectName, NULL, NULL, fname);
			c++;
		}
		num=1;
	}
	DEBUG_OUT("OK.\n");
	return 0;
}

void FixNumber(char *p) {
	unsigned int i;

	DEBUG_OUT("Fixing up phone number '%s'...", p);
	for (i=0;i<strlen(p);i++)
		if (p[i] && (p[i]<'0' || p[i]>'9')) {
			memmove(p+i, p+i+1, strlen(p+i));
			i--;
		}
	DEBUG_OUT("OK.\n");
}
/*
int httpGatewayInit(HANDLE hConn, NETLIBOPENCONNECTION* nloc, NETLIBHTTPREQUEST* nlhr)
{
	NETLIBHTTPPROXYINFO nlhpi = {0};
	nlhpi.cbSize = sizeof(nlhpi);
	nlhpi.szHttpGetUrl = NULL;
	nlhpi.szHttpPostUrl = NULL;
	return CallService(MS_NETLIB_SETHTTPPROXYINFO, (WPARAM)hConn, (LPARAM)&nlhpi);
}
*/

/* Do initial module startup tasks */
static int Init(WPARAM wParam, LPARAM lParam) {
	NETLIBUSER nlu = {0};
	CLISTMENUITEM mi;
	PROTOCOLDESCRIPTOR pd;
	HANDLE hContact;

	// Initialize Netlib
	nlu.cbSize = sizeof(nlu);
	nlu.flags = NUF_OUTGOING; // | NUF_HTTPGATEWAY;
	nlu.szDescriptiveName = "HTTP SMS-Gateway connection";
	nlu.szSettingsModule = pszModulename;
//	nlu.pfnHttpGatewayInit = httpGatewayInit;
//	nlu.szHttpGatewayHello = NULL;
	nlu.szHttpGatewayUserAgent = "Mozilla/4.08 [en] (WinNT; U ;Nav)";
	
	if (!(hNetlibUser = (HANDLE)CallService(MS_NETLIB_REGISTERUSER, 0, (LPARAM)&nlu)))
		OUTPUT("SMS plugin startup failure: Error registering NETLIB user");

	/* We will watch for incoming Messages as a filter */
	CreateServiceFunction("WebSMS"PSR_MESSAGE, ReceivedMessage);
    ZeroMemory(&pd, sizeof(pd));
    pd.cbSize = sizeof(pd);
    pd.szName = "WebSMS";
    pd.type = PROTOTYPE_FILTER;
    CallService(MS_PROTO_REGISTERMODULE, 0, (LPARAM)&pd);
	hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDFIRST, 0, 0);
	while (hContact) {
		CallService(MS_PROTO_ADDTOCONTACT, (WPARAM)hContact, (LPARAM)"WebSMS");
        hContact = (HANDLE)CallService(MS_DB_CONTACT_FINDNEXT, (WPARAM)hContact, 0);
    }

	CreateServiceFunction("WebSMS/Send",SendMenuCommand);
	ZeroMemory(&mi,sizeof(mi));
	mi.cbSize=sizeof(mi);
	mi.position=-0x7FFFFFFF;
	mi.flags=0;
	mi.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_SMS));
	mi.pszName="&Send SMS...";
	mi.pszService="WebSMS/Send";
	CallService(MS_CLIST_ADDMAINMENUITEM,0,(LPARAM)&mi);


	// Add SMS-Contextmenu for user contacts
	CreateServiceFunction("SendSMS/MenuCommand",SMSMenuCommand);
	ZeroMemory(&mi,sizeof(mi));
	mi.cbSize=sizeof(mi);
	mi.position=-2000070000;
	mi.flags=0;
	mi.hIcon=LoadIcon(hInst,MAKEINTRESOURCE(IDI_SMS));
	mi.pszName=Translate("&WebSMS Message");
	mi.pszService="SendSMS/MenuCommand";
	hMenuItemSMS = (HANDLE)CallService(MS_CLIST_ADDCONTACTMENUITEM,0,(LPARAM)&mi);

	Activated=DBGetContactSettingByte(NULL, pluginInfo.shortName, "Active", FALSE);
	return 0;
}

int CheckHTTPErrors(NETLIBHTTPREQUEST *nlhrReply, char *szUrl) {
	// Check for errors and free szUrl

	DEBUG_OUT("Called CheckHTTPErrors(*nlhrReply, %s)\n", szUrl);
	if (!nlhrReply) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: Unable to get page %s..\n", szUrl);
		OUTPUT(errsend);
		free(szUrl);
		return -10;
	}
	free(szUrl);
	if(nlhrReply->resultCode<200 || nlhrReply->resultCode>=300) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: Server answered with error #%d: %s\n", nlhrReply->resultCode, nlhrReply->szResultDescr);
		OUTPUT(errsend);
		_HttpFreeRequestStruct(nlhrReply);
		return -11;
	}
	if (!nlhrReply->dataLength || nlhrReply->pData==NULL) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: Zero sized reply. You may try again\n");
		OUTPUT(errsend);
		return -12;
	}
	DEBUG_OUT("CheckHTTPErrors() OK.\n");
	return 0;
}

int GrabCookies(NETLIBHTTPREQUEST *nlhr) {
	int i, j;
	BOOL AddIt;
	char *p;

	DEBUG_OUT("Grabbing cookies...");
	for (i=0; i<nlhr->headersCount; i++) {
//		OUTPUT(" ? Header: %s\n", nlhr->headers[i].szValue);
		if (!strnicmp(nlhr->headers[i].szName, "Set-Cookie", 10)) {
			OUTPUT(" ! Found a Cookie: %s\n", nlhr->headers[i].szValue);
			if ((p=strchr(nlhr->headers[i].szValue, ';'))) p[0]='\0';
			if ((p=strchr(nlhr->headers[i].szValue, ','))) p[0]='\0';
			AddIt=TRUE;
			for (j=0; j<numCookies; j++) {
				// Dupecheck
				if (!strncmp(CookieJar[j].szValue, nlhr->headers[i].szValue, strlen(CookieJar[j].szValue))) {AddIt=FALSE; break;}
				// Replacement check (replace obsolete cookies)
				if (!strncmp(CookieJar[j].szValue, nlhr->headers[i].szValue, (strchr(CookieJar[j].szValue, '=')-CookieJar[j].szValue))) {
					AddIt=FALSE; 
					CookieJar[j].szValue=strdup(nlhr->headers[i].szValue);
					break;
				}
			}
			if (AddIt) {
				CookieJar[numCookies].szName="Cookie";
				CookieJar[numCookies].szValue=strdup(nlhr->headers[i].szValue);
				numCookies++;
				if (numCookies==MAXCOOKIES) {
					OUTPUT (" - Possible problem: We have reached the maximum of cookies\n");
					break;
				}
			}
		}
	}
	OUTPUT("OK, %d Cookies now in jar\n", numCookies);
	return numCookies;
}

// Don't forget to free() the return value!
char *PrepareURL(char *url, SMSDATA *sms, int count, LOGINDATA login, char *CustomVars[MAXCUSTOMV], int numCustomV, char *lastredirectURL, BOOL EncodeData) {
	char *p, *p2, *wrk, *url_, chrleft[5], v[14], *msg=(char *)_NetlibHttpUrlEncode(0,(LPARAM)sms->szMsg);
	int i, j;
	BOOL parse=TRUE;
	VARMAP vars[]= {
		{sms->prefix,		"$Prefix"},
		{sms->number,		"$Number"},
		{msg	    ,		"$Message"},
		{sms->sender,		"$Sender"},
		{chrleft	,		"$Count" },
		{login.username,	"$User"  },
		{login.password,	"$Pass"  },
		{lastredirectURL,	"$LRurl" },
		{NULL		, NULL	   }};
	
	DEBUG_OUT("Preparing URL '%s'...", url);
	url_=strdup(url);
	sprintf(chrleft, "%d", count-strlen(sms->szMsg));
	

	while(parse) {
		if (p=strstr(url_, "$Cookie[")) {
			wrk=strdup(p);
			if (p2=strchr(wrk, ']')) {
				BOOL foundcookie=FALSE;

				p2[0]=0;
				if (p2+1==0) p2--;
				for (j=0; j<numCookies; j++) {
					if (!strncmp(CookieJar[j].szValue, wrk+8, strlen(wrk+8))) {
						unsigned int newsize=strlen(url_)+strlen(CookieJar[j].szValue)-strlen(wrk+8);

						if (newsize>strlen(url_)+1)
							if (!(url_=realloc(url_, newsize))) return NULL;
						p=strstr(url_, "$Cookie[");
						p[0]=0;
						strcat(url_, CookieJar[j].szValue+strlen(wrk+8)+1);
						strcat(url_, p2+1);
						foundcookie=TRUE;
					}
				}
				if (!foundcookie) {
					OUTPUT("Fatal: Required Cookie wasn't found.\n");
					free(wrk);
					return NULL;
				}
			}
			free(wrk);
			continue;
		} 
		parse=FALSE; i=0;
		while (vars[i].name) {
			if ((p=strstr(url_, vars[i].name)) && vars[i].pField) {
				unsigned int newsize, start=0, len=0;
				j=strlen(vars[i].name);
				newsize=strlen(url_)-j+strlen(vars[i].pField)+5;
				if ((p[j]=='[') && (p2=strchr(p+j, ']'))) {
					char *p3;

					p2[0]=0;
					p3=strchr(p+j, ';');
					p3[0]=0;
					start=atoi(p+j+1);
					if (p3+1) len=atoi(p3+1);
					j=p2-p+1;
				}
				if (newsize>strlen(url_)+1) {
					if (!(url_=(char *)realloc(url_, newsize))) {DEBUG_OUT("realloc() FAILURE.\n"); return NULL; }
					p=strstr(url_, vars[i].name); //ptr may be on a different location after realloc
				}
				p[0]=0;
				if (p+j) wrk=strdup(p+j); else wrk=NULL;
				if (start) {
					if (start>strlen(vars[i].pField)) start=0;
					if (start+len>strlen(vars[i].pField) || len<=0) len=strlen(vars[i].pField)-start;
					strncat(url_, vars[i].pField+start, len);
				} else strcat(url_, vars[i].pField);
				if (wrk) {
					strcat(url_, wrk);
					free(wrk);
				}
				parse=TRUE;
			}
			i++;
		}
		for (i=0; i<numCustomV;i++) {
			sprintf(v, "$CustomVar%d", i+1);
			if (strstr(url_, v)) {
				unsigned int newsize;
				char *myvar;

				j=strlen(v);
				if (EncodeData) myvar=(char *)_NetlibHttpUrlEncode(0,(LPARAM)CustomVars[i]);
				else myvar=CustomVars[i];
				newsize=strlen(url_)-j+strlen(myvar)+5;
				if (newsize>strlen(url_)+1) 
					if (!(url_=(char *)realloc(url_, newsize))) {DEBUG_OUT("realloc() FAILURE.\n"); return NULL; }
				p=strstr(url_, v);
				p[0]=0;
				if (p+j) wrk=strdup(p+j); else wrk=NULL;
				strcat(url_, myvar);
				if (wrk) {
					strcat(url_, wrk);
					free(wrk);
				}
				if (EncodeData) HeapFree(GetProcessHeap(),0,myvar);
				parse=TRUE;
			}
		}
	}
	HeapFree(GetProcessHeap(),0,msg);
	DEBUG_OUT("OK: %s\n", url_);
	return url_;
}

/*******************************************************************************/

/*	SendSMS
	
	Send a SMS using the gateway given in *configfile 

	Parameters:
	configfile	- Configfile to process
	login		- Username and Password to logon to the specified gateway, 
				  can be {0} if the gateway dosn't need logon.
	sms			- SMSDATA structure with the data for the msg to send
	pbar		- PBARDATA (hwnd + IDC) of a progressbar to update, can be {0}
	abrt		- BOOL pointer to a variable that indicates, if TRUE, 
				  that the function should abort as soon as possible
				  and return error 0xAB0.
				  Can be NULL if you do not need it

	Return values:
	-1		- No Gateway name specified
	-2		- Found an invalid URL in a Request in config file (not starting with http://)
	-3		- Memory allocation error while parsing URL
	-4		- No 'Type' field in a Request found
	-5		- Request type was POST but no PostString was found
	-6		- Memory allocation error while Building PostData
	-7		- Specified Type is neither POST nor GET
	-8		- The last HTTP-Request returned an error. 
	-9		- Cannot determine host on redirect
	-10		- Unable to get specified page 
	-11		- Server answered with an error code
	-12		- Zero sized reply from Webserver. You may try again.
	-13		- No Request-Section for processing found
	-14		- File contains "Editme=1"

	0		- Request OK
	0xAB0	- Thread was aborted on request (abrt=TRUE)
	0xBAD	- Request failed, no success-Msg received after POSTing request
	0xB00	- Invalid sms-structure supplied
	0xF00	- The specified gateway doesn't support the given prefix

  	The detailled error-message is returned in the global errsend-variable

*/
int SendSMS(char *configfile, LOGINDATA login, SMSDATA *sms, PBARDATA *pbar, BOOL *abrt) {
	char buf[2048], SectName[11], v[13];
	char *szUrl, *defaultUA="Mozilla/4.0", *CustomVars[MAXCUSTOMV], *lastRedirectURL=NULL, *origPrefix=NULL;
	NETLIBHTTPREQUEST nlhr={0},*nlhrReply;
	NETLIBHTTPHEADER headers[MAXCOOKIES+13];
	KEYTABLE keys[255];
	int numHeaders=0, numKeys=0, numCustomV=0, retval=0, iRequest, i, maxchar=0, j, numRedirects;

/*
	FILE *hFile;

    if(!(hFile=fopen(configfile, "R"))) {
		OUTPUT(" * ERROR: Cannot open file %s\n", configfile);
		return -99;
	}
	fclose(hFile);
*/

	DEBUG_OUT("I will send the message: '%s' to %s %s\n", sms->szMsg, sms->prefix, sms->number);

//	return 0;
	if (!sms->number || !sms->prefix || !sms->szMsg) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: Required Parameters were not specified in SMS-structure");
		OUTPUT(errsend);
		return 0xB00;
	}

	memset(errsend, 0, sizeof(errsend));
	OUTPUT (" * Processing file %s...\n", configfile);
	if (!GetPrivateProfileString("Gateway", "Name", "", buf, sizeof(buf), configfile)) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: No Gateway name specified\n");
		OUTPUT(errsend);
		return -1;
	}
	OUTPUT("Processing Gateway %s\n", buf);
	
	if (GetPrivateProfileString("Gateway", "Editme", "", buf, sizeof(buf), configfile)>0) {
		OUTPUT("> User was too dumb to edit config file.\n");
		_snprintf(buf, sizeof(buf), Translate("You have not edited the config file '%s' yet, please insert username and password and delete the line Editme=1."), configfile);
		MessageBox(NULL,buf,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
		return -14;
	}
	j=-1;
	for (i=1;i<256;i++) {
		char *ptr;

		sprintf(SectName, "Prefix%d", i);
		if (!GetPrivateProfileString("Gateway", SectName, "", buf, sizeof(buf), configfile)) break;
		ptr=strchr(buf, ';'); ptr[0]=0;
		if (!strcmp(sms->prefix, buf)) j=0;
	}
	if (j!=0) {
			_snprintf(errsend, sizeof(errsend), " - ERROR: Specified gateway has no support for prefix '%s'\n", sms->prefix);
			OUTPUT(errsend);
			return 0xF00;
	}

	if (pbar->hwnd) {
		for (iRequest=1;iRequest<256;iRequest++) {
			sprintf(SectName, "Request%d", iRequest);
			if (!GetPrivateProfileString(SectName, "URL", "", buf, sizeof(buf), configfile)) break;
		}
		SendDlgItemMessage(pbar->hwnd ,pbar->PROGRESSBAR, PBM_SETRANGE,(WPARAM)0,MAKELPARAM(0, iRequest*10));
	}

	if (GetPrivateProfileString("Gateway", "MaxChars", "", buf, sizeof(buf), configfile))
		maxchar=atoi(buf);
	
	if (pbar->hwnd) SendDlgItemMessage(pbar->hwnd,pbar->PROGRESSBAR, PBM_SETPOS,(WPARAM)0,(LPARAM)0);
	for (iRequest=1;iRequest<256;iRequest++) {

		// Prepare Request
		memset(&nlhr, 0, sizeof(nlhr));
		nlhr.cbSize=sizeof(nlhr);
		nlhr.flags=NLHRF_GENERATEHOST | NLHRF_DUMPASTEXT | NLHRF_REMOVEHOST;

		if (pbar->hwnd) SendDlgItemMessage(pbar->hwnd,pbar->PROGRESSBAR,PBM_STEPIT,0,0);
		if (abrt && (BOOL)*abrt==TRUE) {
			_snprintf(errsend, sizeof(errsend), " - ERROR: Sending was aborted on request\n");
			OUTPUT(errsend);
			retval=0xAB0;
			break;
		}
		sprintf(SectName, "Request%d", iRequest);
		if (!GetPrivateProfileString(SectName, "URL", "", buf, sizeof(buf), configfile)) break;
		OUTPUT(" * Processing Request #%d...\n", iRequest);
		if (strnicmp(buf, "http://", 7) && buf[0]!='$' && strnicmp(buf, "https://", 8)) {
			_snprintf(errsend, sizeof(errsend), " - ERROR: Not a valid URL: %s\n", buf);
			OUTPUT(errsend);
			retval=-2;
			break;
		}
		if (!(szUrl=PrepareURL(buf, sms, maxchar, login, CustomVars, numCustomV, lastRedirectURL, FALSE))) { 
			_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while parsing URL\n");
			OUTPUT(errsend);
			retval=-3; 
			break; 
		}

		if (GetPrivateProfileString(SectName, "Delay", "", buf, sizeof(buf), configfile)) {
			OUTPUT(" - ZzzZZzzz... Sleeping %sms...\n", buf);
			Sleep(atoi(buf));
		}

		for (i=1;i<256;i++) {
			char buf2[256];

			sprintf(v, "MapPrefix%d", i);
			if (!GetPrivateProfileString(SectName, v, "", buf, sizeof(buf), configfile)) break;
			sprintf(v, "Prefix%d", i);
			if (!GetPrivateProfileString("Gateway", v, "", buf2, sizeof(buf2), configfile)) break;
			if(!strncmp(buf2, sms->prefix, strlen(sms->prefix))) {
				char *purl;

				OUTPUT("Prefix%d == MapPrefix%d (%s == %s)\n", i, i, buf2, buf);
				if (!(purl=PrepareURL(buf, sms, maxchar, login, CustomVars, numCustomV, lastRedirectURL, FALSE))) {
					_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while parsing URL\n");
					OUTPUT(errsend);
					retval=-3; 
					break; 
				}
				origPrefix=sms->prefix;
				sms->prefix=strdup(purl);
				break;
			}
		}
		if (retval) break;


		// Construct header
		numHeaders=0;
		if (GetPrivateProfileString(SectName, "Referer", "", buf, sizeof(buf), configfile)) {
			char *purl;

			headers[numHeaders].szName="Referer";
			if (!(purl=PrepareURL(buf, sms, maxchar, login, CustomVars, numCustomV, lastRedirectURL, FALSE))) {
				_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while parsing URL\n");
				OUTPUT(errsend);
				retval=-3; 
				break; 
			}
			headers[numHeaders].szValue=strdup(purl);
			numHeaders++;
		}
		if (GetPrivateProfileString(SectName, "Host", "", buf, sizeof(buf), configfile)) {
			headers[numHeaders].szName="Host";
			headers[numHeaders].szValue=strdup(buf);
			numHeaders++;
		}
		if (!GetPrivateProfileString(SectName, "UserAgent", "", buf, sizeof(buf), configfile)) 
			strcpy(buf, defaultUA);
		headers[numHeaders].szName="User-Agent";
		headers[numHeaders].szValue=strdup(buf);
		numHeaders++;

		// Add Cookies
		j=0;
		for (i=0;i<numCookies;i++) { j+=strlen(CookieJar[i].szValue); }
		if (j>0) {
			headers[numHeaders].szName=CookieJar[0].szName;
			headers[numHeaders].szValue=(char *)malloc(numCookies*2+j+1);
			strcpy(headers[numHeaders].szValue, CookieJar[0].szValue);
			for (i=1;i<numCookies;i++) {
				strcat(headers[numHeaders].szValue, "; ");
				strcat(headers[numHeaders].szValue, CookieJar[i].szValue);
			}
			numHeaders++;
		}
		// Default Webbrowser-Headers
		headers[numHeaders].szName="Accept";
		headers[numHeaders++].szValue="text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5";
		headers[numHeaders].szName="Accept-Language";
		headers[numHeaders++].szValue="en-us,en;q=0.5";
		headers[numHeaders].szName="Accept-Charset";
		headers[numHeaders++].szValue="ISO-8859-1,utf-8;q=0.7,*;q=0.7";
		headers[numHeaders].szName="Keep-Alive";
		headers[numHeaders++].szValue="300";

//..Experimental..

// This may be useful for some gateways that have a per-IP limit
// for SMS messages. We will trick them into thinking, that we are
// a proxy-server and spoof the client's IP address.
/*
		headers[numHeaders].szName="Client-ip";
		headers[numHeaders++].szValue="213.47.170.295";
		headers[numHeaders].szName="Via";
		headers[numHeaders++].szValue="HTTP/1.0 proxy.at[C3228545] (Traffic-Server/5.2.1-58896 [uScM])";
		headers[numHeaders].szName="X-Forwarded-For";
		headers[numHeaders++].szValue="213.47.170.295";
		headers[numHeaders].szName="X-Forwarded";
		headers[numHeaders++].szValue="213.47.170.295";
		headers[numHeaders].szName="Cache-Control";
		headers[numHeaders++].szValue="max-stale=0";
*/

		OUTPUT(" - Current headers: \n");
		for (i=0;i<numHeaders;i++) OUTPUT(" > %s: %s\n", headers[i].szName, headers[i].szValue);

		if (!GetPrivateProfileString(SectName, "Type", "", buf, sizeof(buf), configfile)) {
			_snprintf(errsend, sizeof(errsend), " - ERROR: No 'Type' for Request found.\n");
			OUTPUT(errsend);
			free(szUrl);
			retval=-4;
			break;
		}

		// POST or GET da stuff
		if (!stricmp(buf, "POST")) {
			OUTPUT(" - Posting Data to %s...\n", szUrl);
			if (GetPrivateProfileString(SectName, "PostString", "", buf, sizeof(buf), configfile)) {
				char *purl;

				if (!(purl=PrepareURL(buf, sms, maxchar, login, CustomVars, numCustomV, lastRedirectURL, TRUE))) {
					_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while parsing URL\n");
					OUTPUT(errsend);
					retval=-3; 
					break; 
				}
				nlhr.pData=purl;
//				nlhr.dataLength=lstrlen(buf);
				nlhr.dataLength=lstrlen(purl);
			} else {
				_snprintf(errsend, sizeof(errsend), " - ERROR: No Poststring specified\n");
				OUTPUT(errsend);
				free(szUrl);
				retval=-5;
				break;
			}

			headers[numHeaders].szName="Content-Type";
			headers[numHeaders].szValue="application/x-www-form-urlencoded";
			numHeaders++;

			// Attach Fetched tokens if there are some..
			if (numKeys>0)
			{
				for (i=0;i<numKeys;i++) {
					int len;
					_snprintf (buf, sizeof(buf), "%s=", keys[i].key);

					if (strstr(nlhr.pData, buf)) continue;
					len = strlen(nlhr.pData);
					if (!(nlhr.pData=realloc(nlhr.pData, (nlhr.dataLength = len+strlen(keys[i].key)+strlen(keys[i].value)+2)+1))) {
						_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while Building PostData\n");
						OUTPUT(errsend);
						retval=-6;
						break;
					}
					nlhr.pData[len]=0;
					strcat(nlhr.pData, "&");
					strcat(nlhr.pData, keys[i].key);
					strcat(nlhr.pData, "=");
					strcat(nlhr.pData, keys[i].value);
				}
				if (retval==-6) break;
			}
/*
			j=0;
			for (i=0;i<numKeys;i++) j+=strlen(keys[i].key)+strlen(keys[i].value)+2;
			if (i>0) {
//				nlhr.dataLength=strlen(nlhr.pData)+j+2;
				nlhr.dataLength=strlen(nlhr.pData)+j;
				if (!(nlhr.pData=realloc(nlhr.pData, nlhr.dataLength+2))) {
					_snprintf(errsend, sizeof(errsend), " - ERROR: Memory allocation error while Building PostData\n");
					OUTPUT(errsend);
					retval=-6;
					break;
				}
				for (i=0;i<numKeys;i++) {
					strcat(nlhr.pData, "&");
					strcat(nlhr.pData, keys[i].key);
					strcat(nlhr.pData, "=");
					strcat(nlhr.pData, keys[i].value);
				}
			}
*/
			// Post Page
			OUTPUT(" - Postdata: %s\n", nlhr.pData);
			nlhr.requestType=REQUEST_POST;
			nlhr.headersCount=numHeaders;
			nlhr.headers=headers;
			nlhr.szUrl=szUrl;
//			nlhr.dataLength=strlen(nlhr.pData)+1;
			nlhr.dataLength=strlen(nlhr.pData);
			nlhrReply=_HTTPtransaction(&nlhr);
		} else if (!stricmp(buf, "GET")) {
			// Get Page
			nlhr.requestType=REQUEST_GET;
			nlhr.headersCount=numHeaders;
			nlhr.headers=headers;
			nlhr.szUrl=szUrl;
			nlhr.dataLength=0;
			OUTPUT(" - Getting Data from %s...\n", nlhr.szUrl);
			nlhrReply=_HTTPtransaction(&nlhr);
		} else {
			_snprintf(errsend, sizeof(errsend), " - ERROR: Type '%s' is neither POST, nor GET.\n", buf);
			OUTPUT(errsend);
			free(szUrl);
			for (i=0;i<numHeaders;i++) free(headers[i].szValue);
			retval=-7;
			break;
		}

		numRedirects = 0;
		do {
			if (nlhrReply) OUTPUT (" - Data received\n"); else {
				_snprintf(errsend, sizeof(errsend), " - ERROR: The last HTTP-Request returned an error. Exiting.\n(HINT: Check your proxy settings)\n");
				OUTPUT(errsend);
				retval=-8;
				iRequest=2; // prevent wrong error message
				break;
			}

			// Put the cookies in the cookie-jar
			numCookies=GrabCookies(nlhrReply);

			if (nlhrReply->resultCode>=301 && nlhrReply->resultCode<=303) {	// Found - Redirection
				for (i=0; i<nlhrReply->headersCount; i++) {
					if (!strnicmp(nlhrReply->headers[i].szName, "Set-Cookie", 10)) {
						// Rebuild headers if there is a new Cookie to add
						if (numCookies==1) {
							headers[numHeaders++].szName="Cookie";
							headers[numHeaders].szValue=strdup("");
						}
						for (j=0; j<numHeaders; j++) {
							if (!strcmp(headers[j].szName, "Cookie")) {
								int k;

								free(headers[j].szValue);
								headers[j].szValue=(char *)calloc(1, strlen(CookieJar[0].szValue)+1);
								strcpy(headers[j].szValue, CookieJar[0].szValue);
								for (k=1;k<numCookies;k++) {
									headers[j].szValue=(char *)realloc(headers[j].szValue, strlen(headers[j].szValue)+3+strlen(CookieJar[k].szValue));
									strcat(headers[j].szValue, "; ");
									strcat(headers[j].szValue, CookieJar[k].szValue);
								}
								break;
							}
						}
						i=nlhrReply->headersCount;
					}
				}
				for (i=0; i<nlhrReply->headersCount; i++) {
					if (!strnicmp(nlhrReply->headers[i].szName, "Location", 8)) {
						nlhr.requestType=REQUEST_GET;
						nlhr.dataLength=0;
						nlhr.pData=NULL;
						// Set Host-Entry, if no host  is given in Redirect-Target
						if (nlhrReply->headers[i].szValue[0]=='/') {
							char *ptr;

							for (j=0, ptr=szUrl; j<3; j++) {
								if (!(ptr=strchr(ptr+1, '/'))) {
									_snprintf(errsend, sizeof(errsend), " - ERROR: Cannot determine host on redirect\n");
									OUTPUT(errsend);
									retval=-9;
									break;
								}
							}
							if (!ptr) break;
							ptr[0]=0;
							szUrl=realloc(szUrl, strlen(szUrl)+strlen(nlhrReply->headers[i].szValue)+2);
							strcat(szUrl, nlhrReply->headers[i].szValue);
							nlhr.szUrl=szUrl;
						} else if (strncmp(nlhrReply->headers[i].szValue, "http", 4)) {
							char *ptr=NULL, *lptr;

							for (ptr=szUrl;*ptr;ptr++) {
								lptr=ptr;
								if (!(ptr=strchr(ptr, '/'))) break;
							}
							lptr[0]=0;
							szUrl=realloc(szUrl, strlen(szUrl)+strlen(nlhrReply->headers[i].szValue)+2);
							strcat(szUrl, nlhrReply->headers[i].szValue);
							nlhr.szUrl=szUrl;
						} else {
							szUrl=realloc(szUrl, strlen(nlhrReply->headers[i].szValue)+1);
							strcpy(szUrl, nlhrReply->headers[i].szValue);
							nlhr.szUrl=szUrl;
						}
						OUTPUT(" - 302- Redirecting to: %s\n", nlhr.szUrl);
						_HttpFreeRequestStruct(nlhrReply);
						if (!(nlhrReply=_HTTPtransaction(&nlhr))) {
							_snprintf(errsend, sizeof(errsend), " - ERROR: The last HTTP-Request returned an error. Exiting.\n(HINT: Check your proxy settings)\n");
							OUTPUT(errsend);
							retval=-8;
							iRequest=2; // prevent wrong error message
							break;
						}
						if (lastRedirectURL) free(lastRedirectURL);
						lastRedirectURL=strdup(nlhr.szUrl);
						numCookies=GrabCookies(nlhrReply);
						break;
					}
				}
				if (retval) break;
			}
			numRedirects++;
		} while (nlhrReply->resultCode>=301 && nlhrReply->resultCode<=303 && numRedirects<MAX_REDIRECTS);
		if (numRedirects == MAX_REDIRECTS) 
		{
			_snprintf(errsend, sizeof(errsend), " - ERROR: Got stuck in an infinite redirection loop (headerscount = %d)\n", nlhrReply->headersCount);
			OUTPUT(errsend);
			retval = -9;
			break;
		}
		if (retval) break;

		// Check for errors
		if (retval=CheckHTTPErrors(nlhrReply, szUrl)) break;

		// Extract custom vars
		sprintf(v, "CustomVar%d", numCustomV+1);
		if (GetPrivateProfileString(SectName, v, "", buf, sizeof(buf), configfile)) {
			char *pstart, *pend, *pafter=NULL, *p, *p2;

			for(i=numCustomV+1;i<256;i++) {
				sprintf(v, "CustomVar%d", i);
				if (!GetPrivateProfileString(SectName, v, "", buf, sizeof(buf), configfile)) break;
				// If brackets are not given, assume that the whole string will
				// be processed, otherwise remove the brackets from string
				if (!(pstart=strchr(buf, '('))) pstart=buf; else {
					if (pstart[1]) {
						memmove(pstart, pstart+1, strlen(pstart+1));
						buf[strlen(buf)-1]=0;
					}
				}
				if (!(pend=strchr(buf, ')'))) pend=buf+strlen(buf); else {
					if (pend[1]) {
						memmove(pend, pend+1, strlen(pend+1));
						buf[strlen(buf)-1]=0;
					}
				}
				// If there is a * joker, process it:
				if (pafter=strchr(buf, '*')) {
					pafter[0]=0;
					pafter++;
				}
				// Now search for our string
				if (p=strstr(nlhrReply->pData, buf)) {
					p=strdup(p);
					j=pend-pstart;
					pstart=p+(pstart-buf);
					if (pafter) {
						if (p2=strstr(p+strlen(buf)+1, pafter)) {
							p2[(pend-pafter)]=0;
						}
					} else
						pstart[j]=0;
					OUTPUT(" - Got custom variable %s: %s\n", v, pstart);
					if (numCustomV>MAXCUSTOMV) 
						OUTPUT(" - WARNING: Maximum number of custom variables reached. \n");
					else {
						CustomVars[numCustomV]=strdup(pstart);
						numCustomV++;
					}
					free(p);
				}
			}
		}

		// Find Keys
		sprintf(v, "Key%d", numKeys+1);
		if (GetPrivateProfileString(SectName, v, "", buf, sizeof(buf), configfile)) {
			char *srch, *p, *p2;

			for (i=numKeys+1;i<256;i++) {
				sprintf(v, "Key%d", i);
				if (!GetPrivateProfileString(SectName, v, "", buf, sizeof(buf), configfile)) break;
				srch=(char *)malloc(strlen(buf)+9);
				strcpy(srch, " name=\"");
				strcat(srch, buf);
				strcat(srch, "\"");
				if (p=strstr(nlhrReply->pData, srch)) {
reparse:
					if (p=strstr(p, "value=\"")) {
						p+=7;
						if (p2=strchr(p, '\"')) {
							p2[0]='\0';
							keys[numKeys].key=strdup(buf);
							keys[numKeys].value=strdup(p);
							OUTPUT(" - Found key %s=%s\n", buf, p);
							numKeys++;
							p2[0]='\"';
						}
					}
				} else {
					/* If you use names without spaces, you don't need the "", so parse this way too */
					strcpy(srch, " name=");
					strcat(srch, buf);
					strcat(srch, " ");
					if (p=strstr(nlhrReply->pData, srch)) goto reparse;
				}
			}
		}

		// Search for SELECTs if the user wants us to do this
		if (GetPrivateProfileString(SectName, "UseSelectData", "", buf, sizeof(buf), configfile)) {
			char *pSelect=nlhrReply->pData;

			while (pSelect=stristr(pSelect+1, "<select"))
			{
				char c, *pOption=pSelect, *pSelectEnd = strstr(pSelect, "</select"), *pSelectStatementEnd = strchr (pSelect, '>'), *pName;
				BOOL bFirstEntry = TRUE;
				
				if (!pSelectStatementEnd) break;
				if (!pSelectEnd) pSelectEnd = nlhrReply->pData + strlen (nlhrReply->pData);
				if ((pName = stristr (pOption, "name")) && (pName+=4)<pSelectStatementEnd &&
					(pName = strchr (pName, '=')))
				{
					char *pStart, *pEnd;

					if (pStart = strchr (++pName, '\"')) pName=pStart+1;
					pEnd = strchr (pName, pStart?'\"':' ');
					if (pStart && !pEnd) pEnd = strchr (pName, '>');
					if (!pEnd) continue;
					c = *pEnd;
					*pEnd = 0;
					keys[numKeys].key=strdup(pName);
					*pEnd = c;
				} else continue;

				while ((pOption = stristr(pOption+1, "<option")) && pOption<pSelectEnd)
				{
					char *pOptionStatementEnd = strchr(pOption, '>'), *pValue, *pEnd;

					if (!pOptionStatementEnd) break;
					if (!bFirstEntry && (!(pValue = stristr (pOption, "selected")) ||  pValue > pOptionStatementEnd)) continue;
					if (!bFirstEntry) numKeys--;
					bFirstEntry=FALSE;

					// Check if there is a value= defined.
					if ((pValue = stristr (pOption, "value")) && (pValue+=5)<pOptionStatementEnd &&
						(pValue = strchr (pValue, '=')))
					{
						char *pStart;

						if (pStart = strchr (++pValue, '\"')) pValue=pStart+1;
						pEnd = strchr (pValue, pStart?'\"':' ');
						if (pStart && !pEnd) pEnd = strchr (pValue, '>');
					} else {
						pValue = pOptionStatementEnd+1;
						pEnd = strchr (pValue, '<');
					}
					if (!pEnd) continue;
					c = *pEnd;
					*pEnd = 0;
					while (*pValue == ' ' || *pValue == 10 || *pValue == 13) pValue++;
					keys[numKeys].value=strdup(pValue);
					{
						char *p=keys[numKeys].value+strlen(pValue)-1;

						while ( *p==' ' || *p==10 || *p==13 ) { *p=0; p--; }
					}
					OUTPUT(" - Found <select> %s=%s\n", keys[numKeys].key, keys[numKeys].value);
					numKeys++;
					*pEnd = c;
				}
			}
		}

		sprintf(SectName, "Request%d", iRequest+1); // Last request?
		if (!GetPrivateProfileString(SectName, "URL", "", buf, sizeof(buf), configfile))
			if (GetPrivateProfileString("Gateway", "Success", "", buf, sizeof(buf), configfile))
				if (!strstr(nlhrReply->pData, buf)) {
					OUTPUT(" - Sending the SMS failed - We didn't get the successmsg we expected :(\n");
					retval=0xBAD;
				}

		if (DBGetContactSettingByte(NULL, pluginInfo.shortName, "Verbose", 0))
			OUTPUT("Result: %s\n", nlhrReply->pData);

		// Free memory
		_HttpFreeRequestStruct(nlhrReply);
	}
	if (iRequest<=1 && !retval) {
		_snprintf(errsend, sizeof(errsend), " - ERROR: No Request-Section '%s' for processing found.\n", SectName);
		OUTPUT(errsend);
		retval=-13;
	}

	if (origPrefix) {
		free(sms->prefix);
		sms->prefix=origPrefix;
		origPrefix=NULL;
	}

	if (lastRedirectURL) free(lastRedirectURL);
			
	// Make Cookie jar empty *munchmunch* :)
	for (i=0;i<numCookies;i++) {
		if (CookieJar[i].szValue) free(CookieJar[i].szValue);
	}
	numCookies=0;
	return retval;
}

int InsertPageNum(SMSDATA* sms, unsigned int curpage, unsigned int origmsglen, unsigned int maxmsglen) {
	if (DBGetContactSettingByte(NULL, pluginInfo.shortName, "NumberMsgs", 0)) {
		char pagenum[8];
		int max, total=(int)ceil((double)origmsglen/(double)maxmsglen);

		DEBUG_OUT("I have to number the messages.\n");
		if (total>(max=DBGetContactSettingWord(NULL, pluginInfo.shortName, "SplitNumber", 2))) total=max;
		_snprintf(pagenum, sizeof(pagenum), "%d/%d", curpage, total);
		if (!(sms->szMsg=(char *)realloc(sms->szMsg, strlen(sms->szMsg)+strlen(pagenum)+1))) {
			SHOWERROR("Memory allocation error in InsertPageNum");
			return -1;
		}
		memmove(sms->szMsg+strlen(pagenum), sms->szMsg, strlen(sms->szMsg)+1);
		memcpy(sms->szMsg, pagenum, strlen(pagenum));
		return strlen(pagenum);
	} else return -1;
}

void SendSMSThread(SENDTPARAM *params) {
	SMSDATA sms={0};
	DBVARIANT dbv;
	PBARDATA pbar;
	LOGINDATA login={0};
	HWND hwndDlg=params->hwndDlg;
	int i;
	unsigned int splitted=0, acnum=0, origmsglen;
	char buf[1024], c, *fname;

DEBUG_OUT("SendSMSThread called with parameters: hContact=%d, hwndDlg=%d\n", params->hContact, params->hwndDlg);
	CallService(MS_SYSTEM_THREAD_PUSH, 0, 0);
	SetEvent(params->hEvent);

	pbar.hwnd=hwndDlg;
	pbar.PROGRESSBAR=IDC_PROGRESS;
	sms.prefix=(char *)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETITEMDATA, SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_GETCURSEL,0,0), 0);

	GetDlgItemText(hwndDlg, IDC_MESSAGE, buf, sizeof(buf));
	if (buf[0]==0) {
		SetDlgItemText(hwndDlg, IDC_STATUS, "I need a message to send!");
		SetFocus(GetDlgItem(hwndDlg, IDC_MESSAGE));
		DEBUG_OUT("No message to send.\n");
		CallService(MS_SYSTEM_THREAD_POP, 0, 0);
		return;
	}
	GetDlgItemText(hwndDlg, IDC_NUMBER, buf, sizeof(buf));
	if (buf[0]==0) {
		SetDlgItemText(hwndDlg, IDC_STATUS, "And WHERE should I send it to?");
		DEBUG_OUT("No number to send to.\n");
		SetFocus(GetDlgItem(hwndDlg, IDC_NUMBER));
		CallService(MS_SYSTEM_THREAD_POP, 0, 0);
		return;
	}
	sms.number=strdup(buf);
	EnableWindow(GetDlgItem(hwndDlg, IDSEND), FALSE);

	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "SenderNumber", &dbv))
		sms.sender=dbv.pszVal;
	else sms.sender=NULL;

    GetDlgItemText(hwndDlg, IDC_MESSAGE, buf, sizeof(buf));
	origmsglen=strlen(buf);

	for (i=0;i<ListSize();i++) {
		char *p;

		DEBUG_OUT("Trying Gateway #%d\n", i);
		if (!Gateways->next->bEnabled) {
			DEBUG_OUT ("Skipping, as it is disabled.");
			ListRotate();
			continue;
		}
		DEBUG_OUT("Trying to read Gateway name from %s", Gateways->next->fullpath);
		if (!GetPrivateProfileString("Gateway", "Name", "", buf, sizeof(buf), Gateways->next->fullpath))
			CopyMemory(buf, Gateways->next->filename, sizeof(buf));
		DEBUG_OUT("Now showing our gateway.\n");
		SetDlgItemText(hwndDlg, IDC_STATUS, buf);
		DEBUG_OUT("Getting message from window.\n");
#ifdef _UNICODE 
{
        wchar_t wcbuf[sizeof(buf)*sizeof(wchar_t)];
        DWORD dwProcId;

        GetLocaleInfo (LOWORD(GetKeyboardLayout(GetWindowThreadProcessId (hwndDlg, &dwProcId))), LOCALE_IDEFAULTANSICODEPAGE, buf, sizeof(buf));
	    if (!GetDlgItemTextW(hwndDlg, IDC_MESSAGE, wcbuf, sizeof(wcbuf) / sizeof(wchar_t)))
		{
	      GetDlgItemTextA(hwndDlg, IDC_MESSAGE, buf, sizeof(buf));
		} else {
          WideCharToMultiByte (atoi(buf), 0, wcbuf, -1, buf, sizeof(buf), NULL, NULL);
		}
}
#else
        GetDlgItemTextA(hwndDlg, IDC_MESSAGE, buf, sizeof(buf));
#endif
		DEBUG_OUT("Stuffing Message into sms-Structure.\n");
		sms.szMsg=strdup(buf);
retry_otheraccount:
		DEBUG_OUT("Now fetching account data.\n");
		CopyMemory(buf, Gateways->next->fullpath, sizeof(buf));
		if (p=strstr(buf, ".ini")) {
			char SectName[12];

			DEBUG_OUT("Probing if there is a .sac file for this Gateway...");
			p[0]=0;
			strcat(buf, ".sac");
			fname=strdup(buf);
			sprintf(SectName, "Account%d", acnum+1);
			if (GetPrivateProfileString(SectName, "Username", "", buf, sizeof(buf), fname)) {
				OUTPUT(" * Trying to send SMS with user '%s'\n", buf);
				acnum++;
				login.username=strdup(buf);
				if (GetPrivateProfileString(SectName, "Password", "", buf, sizeof(buf), fname))
					login.password=strdup(buf); else login.password=NULL;
				DEBUG_OUT("Yes, username=%s, password=%s\n", login.username, login.password);
			} else if (acnum>0) {
				DEBUG_OUT("Reached end of Accountlist.\n");
				free(fname);
				acnum=0;
				continue;
			} else {DEBUG_OUT("No, there isn't.\n");}
			free(fname);
		}
		if (!acnum) {
			DEBUG_OUT("Fetching default usernames from config: ");
			if (GetPrivateProfileString("Gateway", "Username", "", buf, sizeof(buf), Gateways->next->fullpath))
				login.username=strdup(buf); else login.username=NULL;
			if (GetPrivateProfileString("Gateway", "Password", "", buf, sizeof(buf), Gateways->next->fullpath))
				login.password=strdup(buf); else login.password=NULL;
			DEBUG_OUT("User: %s, Pass: %s\n", login.username, login.password);
		}

		if (GetPrivateProfileString("Gateway", "MaxChars", "", buf, sizeof(buf), Gateways->next->fullpath) && (unsigned int)strlen(sms.szMsg)>(unsigned int)atoi(buf)) {
			if (DBGetContactSettingDword(NULL, pluginInfo.shortName, "OnTooLong", IDC_CUT)==IDC_CUT) {
				DEBUG_OUT("Cutting message!\n");
				c=sms.szMsg[atoi(buf)];
				sms.szMsg[atoi(buf)]=0;
				if (!SendSMS(Gateways->next->fullpath, login, &sms, &pbar, &AbortSending)) { i=-1; break; }
			} else {
				unsigned int cutat=atoi(buf);
				int len;
				DEBUG_OUT("Splitting message!\n");
				
				if ((len=InsertPageNum(&sms, splitted+1, origmsglen, cutat))>0) cutat-=len;
				c=sms.szMsg[cutat];
				sms.szMsg[cutat]=0;

				if (!SendSMS(Gateways->next->fullpath, login, &sms, &pbar, &AbortSending)) {
					sms.szMsg[cutat]=c;
					SetDlgItemText(hwndDlg, IDC_MESSAGE, sms.szMsg+cutat);
					i=-1;
					if (splitted++==(unsigned int)DBGetContactSettingWord(NULL, pluginInfo.shortName, "SplitNumber", 2)) break;
					else continue;
				}
			}
		} else {
			if (splitted) InsertPageNum(&sms, splitted+1, origmsglen, atoi(buf));
			if (!SendSMS(Gateways->next->fullpath, login, &sms, &pbar, &AbortSending)) { i=-1; break; }
		}
		if (AbortSending==TRUE) {
			DEBUG_OUT("Sending was aborted by user.\n");
			EnableWindow(GetDlgItem(hwndDlg, IDSEND), TRUE);
			break;
		}
		if (acnum) goto retry_otheraccount;
		free(sms.szMsg);
		if (login.username) free(login.username);
		if (login.password) free(login.password);
		ListRotate();
	}
	if (sms.sender) DBFreeVariant(&dbv);
	free(sms.number);
	if (AbortSending==TRUE) {
		AbortSending=FALSE;
		SendMessage(hwndDlg, WM_COMMAND, IDCANCEL, 0);
		CallService(MS_SYSTEM_THREAD_POP, 0, 0);
		return;
	}
	EnableWindow(GetDlgItem(hwndDlg, IDSEND), TRUE);
	if (i>-1) {
		SetDlgItemText(hwndDlg, IDC_STATUS, "Sending to all gateways failed, sorry");
		if (params->hContact) {
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FailureMsg", &dbv)) {
				CallContactService(params->hContact,PSS_MESSAGE,0,(LPARAM)dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			SendMessage(hwndDlg, WM_COMMAND, IDCANCEL, 0);
		}
	} else {
		OUTPUT("* We succeeded!! :-)\n");
		SetDlgItemText(hwndDlg, IDC_STATUS, "Message sent successfully");
		if (params->hContact) {
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "SuccessMsg", &dbv)) {
				CallContactService(params->hContact,PSS_MESSAGE,0,(LPARAM)dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			SendMessage(hwndDlg, WM_COMMAND, IDCANCEL, 0);
		}
		if (acnum>1) AccountsRotate(fname, acnum);
	}
	CallService(MS_SYSTEM_THREAD_POP, 0, 0);
}

/*******************************************************************************/

/* Just for Testing */

static int SendMenuCommand(WPARAM wParam,LPARAM lParam)
{
	DEBUG_OUT("User clicked on Send menu item.\n");
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_SMSDLG),NULL,SendDlgProc,(LPARAM)NULL);
	return 0;
}

void FreeSMSData (SMSDATA *psms)
{
	free (psms->prefix);
	free (psms->number);
	free (psms->szMsg);
	free (psms->sender);
}

SMSDATA ExtractPhoneNumber (char *szNumber)
{
	SMSDATA sms={0};
	char *p;

	if (p=strchr(szNumber, ')')) {
		p[0]=0;
		FixNumber(szNumber);
		sms.prefix=strdup(szNumber);
		DEBUG_OUT("o_smsdata: %s\n", sms.prefix);
		if (++p) {
			FixNumber(p);
			sms.number=strdup(p);
		}
	} else {
		int i=0;

		FixNumber(szNumber);
		while (Prefixes[i])
		{
			if (!strncmp (Prefixes[i], szNumber, strlen(Prefixes[i])))
			{
				char *ptr = szNumber + strlen(Prefixes[i]), c = *ptr;
						
				*ptr=0;
				sms.prefix=strdup(szNumber);
				*ptr=c;
				sms.number=strdup(ptr);
				break;
			}
			i++;
		}
	}
	return sms;
}

SMSDATA GetPhoneNumber (HANDLE hContact)
{
	char *szProto, idstr[16], *pszUserInfo="UserInfo";
	int j;
	SMSDATA sms={0};
	DBVARIANT dbv;

	szProto = (char *) CallService(MS_PROTO_GETCONTACTBASEPROTO, (WPARAM)hContact, 0);
	strcpy (idstr, "Cellular");
	if(!DBGetContactSetting(hContact,szProto,idstr,&dbv)) {
		if(lstrlen(dbv.pszVal)>4 && !lstrcmp(dbv.pszVal+lstrlen(dbv.pszVal)-4," SMS")) goto cell;
	}
	szProto = pszUserInfo;

	for(j=0;;j++) 
	{
		wsprintf(idstr,"MyPhone%d",j);
		if(DBGetContactSetting(hContact,pszUserInfo,idstr,&dbv))
			break;
cell:
		if(lstrlen(dbv.pszVal)>4 && !lstrcmp(dbv.pszVal+lstrlen(dbv.pszVal)-4," SMS")) 
		{
			sms = ExtractPhoneNumber (dbv.pszVal);
		}
		DBFreeVariant(&dbv);
		if (sms.number) {
			// Abuse of this structure, here comes the entry name
			// Format is: szModule\0szSetting
			if (!(sms.szMsg = malloc (strlen(szProto) + strlen (idstr) + 2))) break;
			sprintf (sms.szMsg, "%s\\%s", szProto, idstr);
			*(strchr(sms.szMsg, '\\'))=0;
			break;
		}
		if (sms.prefix) {
			free (sms.prefix);
			sms.prefix=NULL;
		}
	}
	return sms;
}

/*
   Get contact details for the contact in pAbook

   pAbook->cbEntryID and pAbook->lpEntryID must be set to the entry to get data from

   Returns:
    0 - Success
   -1 - Failure
*/
int GetWABDetails(LPADRBOOK lpAdrBook, LPWABOBJECT lpWABObject, ABOOK *pAbook)
{
	LPMAILUSER lpUser;
	SPropTagArray tag;
	LPSPropValue lpProp=NULL;
	ULONG cValues = 0, ulObjType = 0;
	ULONG cbEID = pAbook->cbEntryID;
	LPENTRYID lpEID = pAbook->lpEntryID;
									
	lpAdrBook->lpVtbl->OpenEntry (lpAdrBook, cbEID, lpEID, NULL, 0, &ulObjType, (LPUNKNOWN*)&lpUser);
	tag.cValues = 1;
	tag.aulPropTag[0] = PR_MOBILE_TELEPHONE_NUMBER;
	if ((lpUser->lpVtbl->GetProps (lpUser, &tag, 0, &cValues, &lpProp) == S_OK) && (cValues == 1) && lpProp && (PROP_TYPE (lpProp->ulPropTag) == PT_STRING8)) {
		SMSDATA sms = ExtractPhoneNumber (lpProp->Value.lpszA);

		if (lpProp) lpWABObject->lpVtbl->FreeBuffer(lpWABObject, lpProp);
		if (sms.prefix && !sms.number) free (sms.prefix); else {
			LVITEM it = {0};
			int iRow=-1;

			free (pAbook->szPrefix);
			pAbook->szPrefix=sms.prefix;
			free (pAbook->szNumber);
			pAbook->szNumber=sms.number;

			tag.aulPropTag[0] = PR_SURNAME;
			if ((lpUser->lpVtbl->GetProps (lpUser, &tag, 0, &cValues, &lpProp) == S_OK) && (cValues == 1) && lpProp && (PROP_TYPE (lpProp->ulPropTag) == PT_STRING8)) {
				free (pAbook->szLastName);
				pAbook->szLastName = strdup(lpProp->Value.lpszA);
			}
			if (lpProp) lpWABObject->lpVtbl->FreeBuffer(lpWABObject, lpProp);
			tag.aulPropTag[0] = PR_GIVEN_NAME;
			if ((lpUser->lpVtbl->GetProps (lpUser, &tag, 0, &cValues, &lpProp) == S_OK) && (cValues == 1) && lpProp && (PROP_TYPE (lpProp->ulPropTag) == PT_STRING8)) {
				free (pAbook->szFirstName);
				pAbook->szFirstName = strdup(lpProp->Value.lpszA);
			}
			if (lpProp) lpWABObject->lpVtbl->FreeBuffer(lpWABObject, lpProp);
			return 0;
		}
	}
	return -1;
}

//This function called when user clicked on the "SMS Message" on one of the users.
static int SMSMenuCommand(WPARAM wParam,LPARAM lParam)
{
	SMSDATA sms;
	SENDWPARAM swpar={0};

	DEBUG_OUT("User clicked on contact's send ContextMenuitem.\n");
	sms = GetPhoneNumber ((HANDLE)wParam);
	free (sms.szMsg);
	sms.szMsg=(char *)lParam;
	swpar.sms=&sms;
	DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_SMSDLG),NULL,SendDlgProc,(LPARAM)&swpar);
	FreeSMSData (&sms);
	return 0;
}

static int PrebuildContactMenu(WPARAM wParam, LPARAM lParam) {
	SMSDATA sms;
	HANDLE hContact = (HANDLE)wParam;
	CLISTMENUITEM mi={0};

	mi.cbSize=sizeof(mi);
	mi.flags=CMIM_FLAGS;
	sms = GetPhoneNumber (hContact);
	if (!sms.prefix)
	{
		mi.flags |= CMIF_HIDDEN;
	} else {
		free (sms.prefix);
		free (sms.number);
		free (sms.szMsg);
	}
	CallService(MS_CLIST_MODIFYMENUITEM, (WPARAM)(HANDLE)hMenuItemSMS,(LPARAM)&mi);
	return 0;
}


HANDLE add_contact (char *pszPrefix, char *pszNumber)
{
	HANDLE hContact;
	char bufphone[64];
	char *pszCc, *pszNum="";

	// We have a new contact
	if (!(hContact=(HANDLE)CallServiceSync(MS_DB_CONTACT_ADD, 0, 0))) return NULL;
	DBWriteContactSettingByte(hContact, "CList", "Hidden", 1);
	// We add an entry for the protocol to this contact, even tough we have
	// not registered a protocol by this name. The primary reason for
	// us to do this is, to enable other coders to use the user's adress book
	// for their purposes. I.e. someone could easiely develop a protocol
	// module that lets users send SMS via the contact list as normale messages
	// to contacts. 
	// He just has to hook the sending function and call the service "WebSMS/Send"
	DBWriteContactSettingString (hContact, "Protocol", "p", pszModulename);

	// We cannot ensure that Country code is correctly mapped in prefix
	// therefore the user has to manually correct this in the abook eventually
	if (pszPrefix)
	{
		pszCc=_strdup(pszPrefix);
		if (strlen (pszCc)>2 && pszCc[2]) {
			pszCc[2]=0;
			pszNum=pszPrefix+2;
		}
		_snprintf (bufphone, sizeof(bufphone), "+%s (%s) %s SMS", pszCc, pszNum, pszNumber);
		free (pszCc);
	} else
		strncpy (bufphone, pszNumber, sizeof(bufphone));
	DBWriteContactSettingString (hContact, "UserInfo", "MyPhone0", bufphone);
	return hContact;
}

/*******************************************************************************/

static LRESULT CALLBACK SendDlgEditSubclassProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_CHAR:
			// crtl-enter
			if ((wParam == '\n' || wParam == '\r') && (GetKeyState(VK_CONTROL) & 0x8000)) {
				PostMessage(GetParent(hwnd), WM_COMMAND, IDSEND, 0);
			}
			if (wParam == 1 && GetKeyState(VK_CONTROL) & 0x8000) {      //ctrl-a
				SendMessage(hwnd, EM_SETSEL, 0, -1);
				return 0;
			}
			break;
	}
	return CallWindowProc(SendDlgEditProc, hwnd, msg, wParam, lParam);
}

static LRESULT CALLBACK GWListDlgSubclassProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) {
		case WM_CHAR:
			if (wParam==' ') SendMessage(GetParent(GetParent(hwnd)), PSM_CHANGED, 0, 0);
			if (wParam=='-') SendMessage (GetParent(hwnd), WM_COMMAND, IDC_UP, 0);
			if (wParam=='+') SendMessage (GetParent(hwnd), WM_COMMAND, IDC_DOWN, 0);
			if (wParam=='r' || wParam=='R') SendMessage (GetParent(hwnd), WM_COMMAND, IDC_ROTATE, 0);
			break;
	}
	return CallWindowProc(GWListDlgEditProc, hwnd, msg, wParam, lParam);
}

static int CALLBACK BrowseCallbackProc(HWND hWnd, UINT uMsg, LPARAM lParam,	LPARAM lpData)
{
	switch (uMsg)
	{
		case BFFM_INITIALIZED:
		{
			// set initial directory
			SendMessage(hWnd, BFFM_SETSELECTION, TRUE, lpData);
			break;
		}
	}
	return 0;
}

/*
 * OptionsDlgProc
 *
 * This callback function is called, when the options dialog in Miranda is shown
 * The function contains all necessary stuff to process the options in the dialog
 * and store them in the database, when changed, and fill out the settings-dialog
 * correctly according to the current settings
 */
static int CALLBACK OptionsDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	DBVARIANT dbv;
	char buf[1024];
	static int OnTooLong;
	
	switch (uMsg){
		case WM_INITDIALOG:	
		{
			HANDLE hOpenIcon = LoadImage (hInst, MAKEINTRESOURCE (IDI_OPENPATH), IMAGE_ICON, 16, 16, 0);

			TranslateDialogDefault (hwndDlg);
			SetDlgItemText(hwndDlg, IDC_GWPATH, GatewayPath);
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "SenderNumber", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_SENDER, dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			SetDlgItemInt(hwndDlg, IDC_SPLITMSGS, (unsigned int)DBGetContactSettingWord(NULL, pluginInfo.shortName, "SplitNumber", 2), FALSE);
			OnTooLong=DBGetContactSettingDword(NULL, pluginInfo.shortName, "OnTooLong", IDC_CUT);
			SendMessage(hwndDlg, WM_COMMAND, OnTooLong, 0);
			CheckDlgButton(hwndDlg, IDC_ACTIVATENA, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ActivateOnNA", 0));
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "Trigger", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_TRIGGER, dbv.pszVal);
				DBFreeVariant(&dbv);
			} else SetDlgItemText(hwndDlg, IDC_TRIGGER, "[SMS]");
			SetDlgItemInt(hwndDlg, IDC_INTERVAL, (unsigned int)DBGetContactSettingWord(NULL, pluginInfo.shortName, "UserMsgInterval", 5), FALSE);
			CheckDlgButton(hwndDlg, IDC_ACTIVE, Activated);
			CheckDlgButton(hwndDlg, IDC_DOLOG, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "DoLog", 0));
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "Logfile", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_LOGFILE, dbv.pszVal);
				DBFreeVariant(&dbv);
			} else SetDlgItemText(hwndDlg, IDC_LOGFILE, "sms_log.txt");
			CheckDlgButton(hwndDlg, IDC_VERBOSE, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "Verbose", 0));
			CheckDlgButton(hwndDlg, IDC_USEWAB, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "UseWab", 1));
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "SuccessMsg", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_SUCCESSMSG, dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FailureMsg", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_FAILMSG, dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FloodMsg", &dbv)) {
				SetDlgItemText(hwndDlg, IDC_FLOODMSG, dbv.pszVal);
				DBFreeVariant(&dbv);
			}
			SendDlgItemMessage (hwndDlg, IDC_OPENGWPATH, BM_SETIMAGE, IMAGE_ICON, (LPARAM) hOpenIcon);
			return TRUE;
		}
		case WM_NOTIFY: {
			NMHDR* nmhdr = (NMHDR*)lParam;
			switch (nmhdr->code){
				case PSN_APPLY:
				case PSN_KILLACTIVE:
					GetDlgItemText(hwndDlg, IDC_GWPATH, GatewayPath, sizeof(GatewayPath));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "GatewayPath", GatewayPath);
					GetDlgItemText(hwndDlg, IDC_SENDER, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "SenderNumber", buf);
					DBWriteContactSettingWord(NULL, pluginInfo.shortName, "SplitNumber", (unsigned short)GetDlgItemInt(hwndDlg, IDC_SPLITMSGS, NULL, FALSE));
					DBWriteContactSettingDword(NULL, pluginInfo.shortName, "OnTooLong", OnTooLong);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "ActivateOnNA", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_ACTIVATENA), BM_GETCHECK,0,0)));
					GetDlgItemText(hwndDlg, IDC_TRIGGER, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "Trigger", buf);
					DBWriteContactSettingWord(NULL, pluginInfo.shortName, "UserMsgInterval", (unsigned short)GetDlgItemInt(hwndDlg, IDC_INTERVAL, NULL, FALSE));
					Activated=SendMessage(GetDlgItem(hwndDlg, IDC_ACTIVE), BM_GETCHECK,0,0);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "DoLog", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_DOLOG), BM_GETCHECK,0,0)));
					GetDlgItemText(hwndDlg, IDC_LOGFILE, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "Logfile", buf);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "Verbose", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_VERBOSE), BM_GETCHECK,0,0)));
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "UseWab", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_USEWAB), BM_GETCHECK,0,0)));
					GetDlgItemText(hwndDlg, IDC_SUCCESSMSG, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "SuccessMsg", buf);
					GetDlgItemText(hwndDlg, IDC_FAILMSG, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "FailureMsg", buf);
					GetDlgItemText(hwndDlg, IDC_FLOODMSG, buf, sizeof(buf));
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "FloodMsg", buf);
					DBWriteContactSettingByte(NULL, pluginInfo.shortName, "NumberMsgs", (BYTE)(SendMessage(GetDlgItem(hwndDlg, IDC_NUMBER), BM_GETCHECK,0,0)));
					return TRUE;
			}			
			break; 
		}
		case WM_COMMAND: {
			switch (LOWORD(wParam)) {
				case IDC_CUT:
				case IDC_SPLIT:
					CheckRadioButton(hwndDlg, IDC_CUT, IDC_SPLIT, LOWORD( wParam ));
					OnTooLong=LOWORD(wParam);
					break;
				case IDC_OPENGWPATH:
				{
					BROWSEINFO bi={0};
					LPITEMIDLIST pidl;
					char szFileName[MAX_PATH];

					GetDlgItemText (hwndDlg, IDC_GWPATH, szFileName, MAX_PATH);
					bi.hwndOwner = hwndDlg;
					bi.lpszTitle = Translate ("Please select the Gateway-path");
					bi.ulFlags   = BIF_RETURNONLYFSDIRS;
					bi.lpfn      = BrowseCallbackProc;
					bi.lParam    = (LPARAM)szFileName;
         
					if ( (pidl = SHBrowseForFolder (&bi)) ) {
						if (SHGetPathFromIDList (pidl, szFileName))
							SetDlgItemText (hwndDlg, IDC_GWPATH, szFileName);

						CoTaskMemFree (pidl);
					} else break;
				}
				case IDC_RESCAN:
				{
					GetDlgItemText(hwndDlg, IDC_GWPATH, GatewayPath, sizeof(GatewayPath));
					SubstitutePath(GatewayPath);
					DBWriteContactSettingString(NULL, pluginInfo.shortName, "GatewayPath", GatewayPath);
					ListCleanup();
					ListInit();
					ScanGatewayList();
					_snprintf(buf, sizeof(buf), Translate("%d Gateways found."), ListSize());
					MessageBox(NULL,buf,pluginInfo.shortName, MB_OK | MB_ICONINFORMATION);
					break;
				}
			}
			SendMessage(GetParent(hwndDlg), PSM_CHANGED, 0, 0);
		}
	}
	return 0;
}

static int CALLBACK OptionsGWListDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	static LPVOID pGwStart = NULL;

	switch (uMsg){
		case WM_SHOWWINDOW:
		{
			struct GWLIST* ptr = Gateways->next;
			HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);
			LVITEM it={0};
			char buf[256];
			int i=0;

			if (ptr == pGwStart) break;
			pGwStart = ptr;
			ListView_DeleteAllItems (hList);
			it.mask=LVIF_TEXT | LVIF_PARAM; 
			while (ptr)
			{
				int iRow=-1;

				GetPrivateProfileString ("Gateway", "Name", "", buf, sizeof(buf), ptr->fullpath);
				it.pszText=buf;
				it.lParam=(LPARAM)ptr;
				it.iItem=i;
				iRow=ListView_InsertItem(hList,&it);
					
				if (iRow!=-1) {
					ListView_SetItemText(hList, iRow, 1, ptr->filename);
				}
				ListView_SetCheckState (hList, iRow, ptr->bEnabled);
				ptr=ptr->next;
				i++;
			}
			TranslateDialogDefault (hwndDlg);
			ListView_SetItemState (hList, 0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);

			break;
		}
		case WM_INITDIALOG:	
		{
			LVCOLUMN lvc = {0};
			HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);
			RECT rc;

			pGwStart = NULL;
			GWListDlgEditProc = (WNDPROC) SetWindowLong(hList, GWL_WNDPROC, (LONG) GWListDlgSubclassProc);
			GetClientRect(hList,&rc);
			rc.right-=GetSystemMetrics(SM_CXVSCROLL);
			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.cx = rc.right / 2;
			lvc.pszText = Translate ("Gateway");
			ListView_InsertColumn(hList,0,&lvc);
			lvc.pszText = Translate ("File");
			ListView_InsertColumn(hList,1,&lvc);
			ListView_SetExtendedListViewStyleEx(hList, 0, LVS_EX_FULLROWSELECT|LVS_EX_CHECKBOXES);

			return TRUE;
		}
		case WM_COMMAND:
			switch (LOWORD(wParam)) {
				case IDC_UP:
				case IDC_DOWN:
				{
					LVITEM lvi={0}, lvi2={0};
					char buf1[256]={0}, buf2[256]={0};
					BOOL bCheck1, bCheck2;
					HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);

					SetFocus (hList);
					if(ListView_GetSelectedCount(hList)!=1) break;
					
					lvi.mask=lvi2.mask=LVIF_PARAM|LVIF_TEXT;
					lvi.cchTextMax = lvi2.cchTextMax = sizeof(buf1);
					lvi.pszText = buf1;
					lvi.iItem=ListView_GetNextItem(hList,-1,LVNI_ALL|LVNI_SELECTED);
					if ((LOWORD(wParam)==IDC_UP && !lvi.iItem) ||
						(LOWORD(wParam)==IDC_DOWN && lvi.iItem==ListView_GetItemCount(hList)-1)) 
						break;

					ListView_GetItem(hList,&lvi);
					bCheck1 = ListView_GetCheckState (hList, lvi.iItem);
					lvi2.iItem = LOWORD(wParam)==IDC_UP?--lvi.iItem:++lvi.iItem;
					bCheck2 = ListView_GetCheckState (hList, lvi2.iItem);
					lvi2.pszText = buf2;
					ListView_GetItem(hList,&lvi2);
					lvi.pszText = buf2;
					LOWORD(wParam)==IDC_UP?lvi2.iItem++:lvi2.iItem--;
					lvi.pszText = buf1;
					ListView_SetItem(hList, &lvi);
					ListView_SetItem(hList, &lvi2);
					ListView_SetCheckState(hList, lvi.iItem, bCheck1);
					ListView_SetCheckState(hList, lvi2.iItem, bCheck2);
					ListView_SetItemText(hList, lvi.iItem, 1, ((struct GWLIST*)(lvi.lParam))->filename);
					ListView_SetItemText(hList, lvi2.iItem, 1, ((struct GWLIST*)(lvi2.lParam))->filename);

					ListView_SetItemState (hList, lvi2.iItem, 0, LVIS_SELECTED | LVIS_FOCUSED);
					ListView_SetItemState (hList, lvi.iItem, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
					SendMessage(GetParent(hwndDlg), PSM_CHANGED, 0, 0);
					break;
				}
				case IDC_ROTATE:
				{
					HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);
					int i, curSel=ListView_GetNextItem(hList,-1,LVNI_ALL|LVNI_SELECTED);
					int nItems = ListView_GetItemCount(hList)-1;

					ListView_SetItemState (hList, curSel, 0, LVIS_SELECTED | LVIS_FOCUSED);
					ListView_SetItemState (hList, 0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
					for (i=0;i<nItems;i++)
					{
						SendMessage (hwndDlg, WM_COMMAND, IDC_DOWN, 0);
					}
					ListView_SetItemState (hList, nItems, 0, LVIS_SELECTED | LVIS_FOCUSED);
					if (!curSel) curSel=1;
					ListView_SetItemState (hList, curSel-1, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
					break;
				}
				case IDC_LOAD:
					ListCleanup();
					ListInit();
					ScanGatewayList();
					pGwStart = NULL;
					SendMessage (hwndDlg, WM_SHOWWINDOW, 0, 0);
					break;
				case IDC_SAVE:
				{
					char buf[MAX_PATH];
					struct GWLIST *pGw;
					LVITEM lvi={0};
					HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);
					FILE *hFile;

					_snprintf (buf, sizeof(buf), "%s\\%s", GatewayPath, pszGWOrderfile);
					if (!(hFile=fopen(buf, "w"))) {
						char bufErrMsg[MAX_PATH+256];
						
						_snprintf (bufErrMsg, sizeof(buf), Translate ("Cannot write to file: %s"), buf);
						MessageBox (hwndDlg, bufErrMsg, NULL, MB_ICONSTOP | MB_OK);
						break;
					}
					lvi.mask=LVIF_PARAM;
					for (lvi.iItem=0; lvi.iItem<ListView_GetItemCount(hList); lvi.iItem++)
					{
						ListView_GetItem(hList,&lvi);
						pGw = (struct GWLIST*)lvi.lParam;
						fprintf (hFile, "%d;%s\n", ListView_GetCheckState (hList, lvi.iItem), pGw->filename);
					}
					fclose (hFile);
					MessageBox (hwndDlg, Translate ("Gateway order saved successfully!"), Translate("Information"), MB_ICONINFORMATION | MB_OK);
					break;
				}
			}
			break;
		case WM_NOTIFY: 
		{
			NMHDR* nmhdr = (NMHDR*)lParam;
			switch (nmhdr->code){
				case PSN_KILLACTIVE:
				case PSN_APPLY:
				{
					HANDLE hList = GetDlgItem (hwndDlg, IDC_GWLIST);
					LVITEM lvi={0};
					struct GWLIST* ptr, *ptrlast = Gateways;

					lvi.mask=LVIF_PARAM;
					for (lvi.iItem=0; lvi.iItem<ListView_GetItemCount(hList); lvi.iItem++)
					{
						ListView_GetItem(hList,&lvi);
						ptr = (struct GWLIST*)lvi.lParam;
						ptr->next = NULL;
						ptr->bEnabled = ListView_GetCheckState (hList, lvi.iItem);
						ptrlast->next = ptr;
						ptrlast=ptr;
					}
				}
			}
			break;
		}
	}
	return FALSE;
}

static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	LPNMLISTVIEW nmlv=(LPNMLISTVIEW)lParamSort;
	ABOOK *pAbook1 = (ABOOK*)lParam1;
	ABOOK *pAbook2 = (ABOOK*)lParam2;

	int sortInt = (int) nmlv->lParam;
	switch (nmlv->iSubItem)
	{
		case 0:
			return lstrcmpi(pAbook1->szFirstName, pAbook2->szFirstName) * sortInt;
		case 1:
			return lstrcmpi(pAbook1->szLastName, pAbook2->szLastName) * sortInt;
		case 2:
			return lstrcmpi(pAbook1->szPrefix, pAbook2->szPrefix) * sortInt;
		case 3:
			return lstrcmpi(pAbook1->szNumber, pAbook2->szNumber) * sortInt;
	}
	return 0;
}


// Stolen from contactinfo.c and enhanced to suit our needs
static BOOL CALLBACK EditUserPhoneDlgProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static ABOOK* pAbook;

	switch(msg) {
		case WM_INITDIALOG:
		{	
			int i,item,countryCount;
			struct CountryListEntry *countries;

			pAbook = (ABOOK*)lParam;
			TranslateDialogDefault(hwndDlg);
			EnableWindow(GetDlgItem(hwndDlg,IDOK),(pAbook->szNumber && pAbook->szNumber[0]));
			EnableWindow(GetDlgItem(hwndDlg,IDC_FIRSTNAME),pAbook->szFirstName!=NULL);
			EnableWindow(GetDlgItem(hwndDlg,IDC_LASTNAME),pAbook->szLastName!=NULL);
			SendDlgItemMessage(hwndDlg,IDC_AREA,EM_LIMITTEXT,31,0);
			SendDlgItemMessage(hwndDlg,IDC_NUMBER,EM_LIMITTEXT,63,0);
			SendDlgItemMessage(hwndDlg,IDC_FIRSTNAME,EM_LIMITTEXT,255,0);
			SendDlgItemMessage(hwndDlg,IDC_LASTNAME,EM_LIMITTEXT,255,0);
			CallService(MS_UTILS_GETCOUNTRYLIST,(WPARAM)&countryCount,(LPARAM)&countries);
			for(i=0;i<countryCount;i++) {
				if(countries[i].id==0 || countries[i].id==0xFFFF) continue;
				item=SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_ADDSTRING,0,(LPARAM)countries[i].szName);
				SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_SETITEMDATA,item,countries[i].id);
			}
			if (pAbook->szNumber)
			{
				pAbook->szNumber[lstrlen(pAbook->szNumber)-4]='\0';
				SetDlgItemText(hwndDlg,IDC_PHONE,pAbook->szNumber);
			}
			if (pAbook->szFirstName) SetDlgItemText(hwndDlg,IDC_FIRSTNAME,pAbook->szFirstName);
			if (pAbook->szLastName) SetDlgItemText(hwndDlg,IDC_LASTNAME,pAbook->szLastName);
			return TRUE;
		}
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				static int noRecursion=0;

				case IDOK:
					{	
						char szText[256];
						int isValid=1;

						GetDlgItemText(hwndDlg,IDC_PHONE,szText,sizeof(szText)-4);
						if(lstrlen(szText)<7 || szText[0]!='+') isValid=0;
						if(isValid) isValid=(lstrlen(szText+1)==(int)strspn(szText+1,"0123456789 ()-"));
						if(!isValid) {
							MessageBox(hwndDlg,Translate("The phone number should start with a + and consist of numbers, spaces, brackets and hyphens only."),Translate("Invalid Phone Number"),MB_OK);
							break;
						}
						lstrcat(szText," SMS");
						free (pAbook->szNumber);
						pAbook->szNumber = _strdup (szText);
						if (pAbook->szFirstName) {
							GetDlgItemText(hwndDlg,IDC_FIRSTNAME,szText, sizeof(szText));
							free (pAbook->szFirstName);
							pAbook->szFirstName = _strdup (szText);
						}
						if (pAbook->szLastName) {
							GetDlgItemText(hwndDlg,IDC_LASTNAME,szText, sizeof(szText));
							free (pAbook->szLastName);
							pAbook->szLastName = _strdup (szText);
						}
					}
					//fall through
				case IDCANCEL:
					EndDialog(hwndDlg,wParam);
				case IDC_COUNTRY:
					if(HIWORD(wParam)!=CBN_SELCHANGE) break;
				case IDC_AREA:
				case IDC_NUMBER:
					if(LOWORD(wParam)!=IDC_COUNTRY && HIWORD(wParam)!=EN_CHANGE) break;
					if(noRecursion) break;
					EnableWindow(GetDlgItem(hwndDlg,IDOK),TRUE);
					{	char szPhone[96],szArea[32],szNumber[64];
						GetDlgItemText(hwndDlg,IDC_AREA,szArea,sizeof(szArea));
						GetDlgItemText(hwndDlg,IDC_NUMBER,szNumber,sizeof(szNumber));
						_snprintf(szPhone,sizeof(szPhone),"+%u (%s) %s",SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_GETITEMDATA,SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_GETCURSEL,0,0),0),szArea,szNumber);
						noRecursion=1;
						SetDlgItemText(hwndDlg,IDC_PHONE,szPhone);
						noRecursion=0;
					}
					break;
				case IDC_PHONE:
					if(HIWORD(wParam)!=EN_UPDATE) break;
					if(noRecursion) break;
					noRecursion=1;
					{	char szText[256],*pText,*pArea,*pNumber;
						int isValid=1;
						GetDlgItemText(hwndDlg,IDC_PHONE,szText,sizeof(szText));
						if(szText[0]!='+') isValid=0;
						if(isValid) {
							int i,country=strtol(szText+1,&pText,10);
							if(pText-szText>4) isValid=0;
							else for(i=SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_GETCOUNT,0,0)-1;i>=0;i--)
									if(country==SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_GETITEMDATA,i,0))
										{SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_SETCURSEL,i,0); break;}
							if(i<0) isValid=0;
						}
						if(isValid) {
							pArea=pText+strcspn(pText,"0123456789");
							pText=pArea+strspn(pArea,"0123456789");
							if(*pText) {
								*pText='\0';
								pNumber=pText+1+strcspn(pText+1,"0123456789");
								SetDlgItemText(hwndDlg,IDC_NUMBER,pNumber);
							}
							SetDlgItemText(hwndDlg,IDC_AREA,pArea);
						}
						if(!isValid) {
							SendDlgItemMessage(hwndDlg,IDC_COUNTRY,CB_SETCURSEL,-1,0);
							SetDlgItemText(hwndDlg,IDC_AREA,"");
							SetDlgItemText(hwndDlg,IDC_NUMBER,"");
						}
					}
					noRecursion=0;
					EnableWindow(GetDlgItem(hwndDlg,IDOK),GetWindowTextLength(GetDlgItem(hwndDlg,IDC_PHONE)));
					break;
			}
			break;
	}
	return FALSE;
}


static BOOL CALLBACK AddrBookDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	static HINSTANCE hInstLib=NULL;
	static LPADRBOOK lpAdrBook = NULL;
	static LPWABOBJECT lpWABObject = NULL;

	switch(message) {
		case WM_INITDIALOG:
		{
			LVCOLUMN lvc;
			RECT rc;
			HWND hNumbers = GetDlgItem(hwndDlg,IDC_NUMBERS);
			HANDLE hContact;

			TranslateDialogDefault (hwndDlg);
			Utils_RestoreWindowPosition(hwndDlg, NULL, pszModulename, "ADDRBOOKdlg");
			GetClientRect(hNumbers,&rc);
			rc.right-=GetSystemMetrics(SM_CXVSCROLL);
			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			lvc.cx = rc.right / 4;
			lvc.pszText = Translate ("First name");
			ListView_InsertColumn(hNumbers,0,&lvc);
			lvc.pszText = Translate ("Last name");
			ListView_InsertColumn(hNumbers,1,&lvc);
			lvc.pszText = Translate ("Prefix");
			ListView_InsertColumn(hNumbers,2,&lvc);
			lvc.pszText = Translate ("Number");
			ListView_InsertColumn(hNumbers,3,&lvc);
			ListView_SetExtendedListViewStyleEx(hNumbers, 0, LVS_EX_FULLROWSELECT);

			// First add the phone numbers of the ICQ-contacts
			for (hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST, 0, 0);hContact != NULL;hContact=(HANDLE)CallService( MS_DB_CONTACT_FINDNEXT, (WPARAM)hContact, 0)) {
				SMSDATA sms = GetPhoneNumber (hContact);

				if (sms.number) {
					LVITEM it = {0};
					DBVARIANT dbv;
					CONTACTINFO ci = {0};
					ABOOK *pAbook = NULL;
					int iRow;

					if (!(pAbook = (ABOOK*)calloc (sizeof(ABOOK), 1))) break;
					if (!DBGetContactSetting (hContact, "Protocol", "p", &dbv)) {
						DBVARIANT dbv2;

						if (!DBGetContactSetting (hContact, dbv.pszVal, "FirstName", &dbv2)) {
							pAbook->szFirstName = _strdup (dbv2.pszVal);
							DBFreeVariant (&dbv2);
						} else
							if (!DBGetContactSetting (hContact, dbv.pszVal, "Nick", &dbv2)) {
								pAbook->szFirstName = _strdup (dbv2.pszVal);
								DBFreeVariant (&dbv2);
							}
						if (!DBGetContactSetting (hContact, dbv.pszVal, "LastName", &dbv2)) {
							pAbook->szLastName = _strdup (dbv2.pszVal);
							DBFreeVariant (&dbv2);
						}
						DBFreeVariant (&dbv);
					}
					pAbook->hContact = hContact;

					it.mask=LVIF_TEXT | LVIF_PARAM; 
					it.pszText=pAbook->szFirstName;
					it.lParam=(LPARAM)pAbook;
					iRow=ListView_InsertItem(hNumbers,&it);
					
					if (iRow!=-1) {
						pAbook->szPrefix = sms.prefix;
						pAbook->szNumber = sms.number;
						pAbook->szDBName = sms.szMsg;
						ListView_SetItemText(hNumbers, iRow, 1, pAbook->szLastName);
						ListView_SetItemText(hNumbers, iRow, 2, pAbook->szPrefix);
						ListView_SetItemText(hNumbers, iRow, 3, pAbook->szNumber);
					} else {
						free (pAbook->szFirstName);
						free (pAbook->szLastName);
						FreeSMSData (&sms);
						free (pAbook);
					}
				}
			}

			// Next, we try to also load the contacts from the Windows Address book, in
			// case it exists.
			// Beware of the mighty COM :P
			// This code somehow works, but feel free to improve.. 
			if (DBGetContactSettingByte(NULL, pluginInfo.shortName, "UseWab", 1))
			{
				char szPath[MAX_PATH];
				LPWABOPEN procWABOpen;
				HKEY hKey;
				DWORD dwType = 0;
				ULONG cbData = sizeof(szPath);

				strcpy (szPath, "wab32.dll");
				if (RegOpenKeyEx (HKEY_LOCAL_MACHINE, "Software\\Microsoft\\WAB\\DLLPath", 0, KEY_READ, &hKey) == ERROR_SUCCESS)
				{
					RegQueryValueEx (hKey, "", NULL, &dwType, (LPBYTE)szPath, &cbData);
					if (hKey) RegCloseKey (hKey);
				}
				if ((hInstLib = LoadLibrary (szPath)) && (procWABOpen = (LPWABOPEN) GetProcAddress (hInstLib, "WABOpen")))
				{
					DWORD Reserved2 = 0;

					if (((procWABOpen) (&lpAdrBook, &lpWABObject, NULL, Reserved2)) == S_OK)
					{
						ULONG lpcbEntryID;
						ENTRYID *lpEntryID;
						
						if (lpAdrBook->lpVtbl->GetPAB(lpAdrBook, &lpcbEntryID, &lpEntryID) == S_OK)
						{
							ULONG ulFlags = 0;
							ULONG ulObjType = 0;
							LPUNKNOWN lpUnk = NULL;

							if (lpAdrBook->lpVtbl->OpenEntry (lpAdrBook, lpcbEntryID, lpEntryID, NULL, ulFlags, &ulObjType, &lpUnk) == S_OK && ulObjType == MAPI_ABCONT)
							{
								IABContainer *lpContainer = (IABContainer*)lpUnk;
								LPMAPITABLE lpTable = NULL;
								ULONG ulRows, i;
								SRowSet *lpRows;
								SizedSPropTagArray (1, mscols) = { 1, {PR_ENTRYID} };

								ulFlags = 0;
								if (lpContainer->lpVtbl->GetContentsTable (lpContainer, ulFlags, &lpTable)==S_OK)
								{
									lpTable->lpVtbl->GetRowCount (lpTable, 0, &ulRows);
									lpTable->lpVtbl->SetColumns (lpTable, (LPSPropTagArray)&mscols, 0);
									if (lpTable->lpVtbl->QueryRows (lpTable, ulRows, 0, &lpRows)==S_OK)
									{
										for (i=0; i<lpRows->cRows;i++)
										{
											ABOOK *pAbook = NULL;
											SRow *lpRow = &lpRows->aRow[i];
											SPropValue *lpMyProp = &lpRow->lpProps[0];

											if (!(pAbook = (ABOOK*)calloc (sizeof(ABOOK), 1))) break;
											if (lpMyProp->ulPropTag == PR_ENTRYID)
											{
												LVITEM it={0};
												pAbook->lpEntryID = (LPENTRYID)lpMyProp->Value.bin.lpb;
												pAbook->cbEntryID = lpMyProp->Value.bin.cb;
										
												if (GetWABDetails (lpAdrBook, lpWABObject, pAbook)==0) {
													int iRow=-1;

													it.mask=LVIF_TEXT | LVIF_PARAM; 
													it.pszText=pAbook->szFirstName;
													it.lParam=(LPARAM)pAbook;
													iRow=ListView_InsertItem(hNumbers,&it);
													if (iRow != -1)
													{
														if (pAbook->szLastName) ListView_SetItemText(hNumbers, iRow, 1, pAbook->szLastName);
														ListView_SetItemText(hNumbers, iRow, 2, pAbook->szPrefix);
														ListView_SetItemText(hNumbers, iRow, 3, pAbook->szNumber);
													} else  {
														free (pAbook->szFirstName);
														free (pAbook->szLastName);
														free (pAbook);
													}
												} else free (pAbook);
											}
											lpWABObject->lpVtbl->FreeBuffer(lpWABObject, lpRow);
										}
										lpWABObject->lpVtbl->FreeBuffer(lpWABObject, lpRows);
									}
									if (lpTable) lpTable->lpVtbl->Release (lpTable);
								}
								if (lpContainer) lpContainer->lpVtbl->Release (lpContainer);
							}
							lpWABObject->lpVtbl->FreeBuffer(lpWABObject, &lpEntryID);
						}
					}
				}
			}

			// Finally correct the size of the columns and loading of address book is done :)
			ListView_SetColumnWidth(hNumbers, 2, LVSCW_AUTOSIZE);
			ListView_SetColumnWidth(hNumbers, 3, LVSCW_AUTOSIZE);
			ListView_SetItemState (hNumbers, 0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
			break;
		}
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_ADD:
				{
					HWND hNumbers = GetDlgItem(hwndDlg,IDC_NUMBERS);
					ABOOK *pAbook;
					LVITEM it = {0};
					SMSDATA sms;
					int iRow;

					if (!(pAbook = (ABOOK*)calloc (sizeof(ABOOK), 1))) break;

					pAbook->szFirstName=strdup("");
					pAbook->szLastName=strdup("");
					it.mask=LVIF_TEXT | LVIF_PARAM; 
					it.lParam=(LPARAM)pAbook;

					if (DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_ADDPHONE),hwndDlg,EditUserPhoneDlgProc,(LPARAM)pAbook)!=IDOK ||
						(it.pszText=pAbook->szFirstName) && (iRow=ListView_InsertItem(hNumbers,&it)) == -1) {
						free (pAbook->szFirstName);
						free (pAbook->szLastName);
						free (pAbook);
						break;
					}
					pAbook->hContact = add_contact (pAbook->szPrefix, pAbook->szNumber);
					free (pAbook->szNumber);
					sms = GetPhoneNumber (pAbook->hContact);
					pAbook->szPrefix = sms.prefix;
					pAbook->szNumber = sms.number;
					pAbook->szDBName = sms.szMsg;
					DBWriteContactSettingString (pAbook->hContact, pszModulename, "FirstName", pAbook->szFirstName);
					DBWriteContactSettingString (pAbook->hContact, pszModulename, "LastName", pAbook->szLastName);
					ListView_SetItemText(hNumbers, iRow, 1, pAbook->szLastName);
					ListView_SetItemText(hNumbers, iRow, 2, pAbook->szPrefix);
					ListView_SetItemText(hNumbers, iRow, 3, pAbook->szNumber);
					break;
				}
				case IDOK:
				case IDC_EDIT:
				case IDC_REMOVE:
				{
					LVITEM lvi={0};
					HWND hNumbers = GetDlgItem(hwndDlg,IDC_NUMBERS);
					HWND hParent = GetParent (hwndDlg);
					ABOOK *pAbook;

					if(ListView_GetSelectedCount(hNumbers)!=1) break;
					lvi.mask=LVIF_PARAM;
					lvi.iItem=ListView_GetNextItem(hNumbers,-1,LVNI_ALL|LVNI_SELECTED);
					ListView_GetItem(hNumbers,&lvi);
					pAbook=(ABOOK*)lvi.lParam;
					switch (LOWORD(wParam))
					{
						case IDOK:
							SendDlgItemMessage(hParent,IDC_NETWORK,CB_SETCURSEL,SendDlgItemMessage(hParent,IDC_NETWORK,CB_FINDSTRING,0,(LPARAM)pAbook->szPrefix),0);
							SetDlgItemText (hParent, IDC_NUMBER, pAbook->szNumber);
							break;
						case IDC_EDIT:
							if (pAbook->hContact) {
								DBVARIANT dbv;
								ABOOK Abook={0};
								SMSDATA sms;

								DBGetContactSetting (pAbook->hContact, "Protocol", "p", &dbv);
								if (!strcmp (dbv.pszVal, pszModulename))
								{
									Abook.szFirstName=pAbook->szFirstName?pAbook->szFirstName:strdup("");
									Abook.szLastName=pAbook->szLastName?pAbook->szLastName:strdup("");
								}
								DBFreeVariant (&dbv);
								Abook.hContact = pAbook->hContact;
								DBGetContactSetting(pAbook->hContact,pAbook->szDBName,pAbook->szDBName+strlen(pAbook->szDBName)+1,&dbv);
								Abook.szNumber = _strdup (dbv.pszVal);
								DBFreeVariant (&dbv);
								if (DialogBoxParam(hInst,MAKEINTRESOURCE(IDD_ADDPHONE),hwndDlg,EditUserPhoneDlgProc,(LPARAM)&Abook)!=IDOK) break;
								if (Abook.szFirstName) {
									DBWriteContactSettingString (pAbook->hContact, pszModulename, "FirstName", Abook.szFirstName);
									pAbook->szFirstName = Abook.szFirstName;
								}
								if (Abook.szLastName) {
									DBWriteContactSettingString (pAbook->hContact, pszModulename, "LastName", Abook.szLastName);
									pAbook->szLastName = Abook.szLastName;
								}
								DBWriteContactSettingString (pAbook->hContact, pAbook->szDBName, pAbook->szDBName + strlen(pAbook->szDBName) +1, Abook.szNumber);
								sms = GetPhoneNumber (pAbook->hContact);
								pAbook->szPrefix = sms.prefix;
								pAbook->szNumber = sms.number;
							} else if (pAbook->cbEntryID)
							{
								ULONG hWnd = (ULONG)hwndDlg;
								
								if (lpAdrBook->lpVtbl->Details (lpAdrBook, &hWnd, NULL, 0, pAbook->cbEntryID, pAbook->lpEntryID, NULL, NULL, NULL, 0)==S_OK)
								{
									GetWABDetails (lpAdrBook, lpWABObject, pAbook);
								}
							}	
							ListView_SetItemText(hNumbers, lvi.iItem, 0, pAbook->szFirstName);
							ListView_SetItemText(hNumbers, lvi.iItem, 1, pAbook->szLastName);
							ListView_SetItemText(hNumbers, lvi.iItem, 2, pAbook->szPrefix);
							ListView_SetItemText(hNumbers, lvi.iItem, 3, pAbook->szNumber);
							break;
						case IDC_REMOVE:
						{
							DBVARIANT dbv;

							DBGetContactSetting (pAbook->hContact, "Protocol", "p", &dbv);
							if (!strcmp (dbv.pszVal, pszModulename))
							{
								CallService (MS_DB_CONTACT_DELETE, (WPARAM)pAbook->hContact, 0);
							} else {
								DBDeleteContactSetting (pAbook->hContact, pAbook->szDBName, pAbook->szDBName + strlen(pAbook->szDBName) + 1);
								if (!strncmp (pAbook->szDBName, "UserInfo", 8))
								{
									int i;
									char buf1[16], buf2[16];

									for (i=atoi (pAbook->szDBName+strlen(pAbook->szDBName)+8); i<255; i++)
									{
										DBVARIANT dbv;

										_snprintf(buf1, sizeof(buf1), "MyPhone%d", i);
										_snprintf(buf2, sizeof(buf2), "MyPhone%d", i+1);
										if (!DBGetContactSetting (pAbook->hContact, "UserInfo", buf2, &dbv)) {
											DBWriteContactSettingString (pAbook->hContact, "UserInfo", buf1, dbv.pszVal);
											DBFreeVariant (&dbv);
											DBDeleteContactSetting (pAbook->hContact, "UserInfo", buf2);
										} else break;
									}
								}
							}
							DBFreeVariant (&dbv);
							ListView_DeleteItem (hNumbers, lvi.iItem);
							ListView_SetItemState (hNumbers, 0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
							free (pAbook->szFirstName);
							free (pAbook->szLastName);
							free (pAbook->szPrefix);
							free (pAbook->szNumber);
							free (pAbook->szDBName);
							free (pAbook);
							break;
						}
					}
					if (LOWORD(wParam)!=IDOK) break;
				}
				case IDCANCEL:
				{
					EndDialog (hwndDlg, 0);
					break;
				}
			}
			break;
		case WM_NOTIFY:
			switch (wParam)
			{
				case IDC_NUMBERS:
					switch(((LPNMHDR)lParam)->code) {
						case LVN_ITEMCHANGED:
						{
							LPNMLISTVIEW pnmv = (LPNMLISTVIEW)lParam;
							ABOOK *pAbook = (ABOOK*)pnmv->lParam;

							EnableWindow (GetDlgItem (hwndDlg, IDOK), (SendDlgItemMessage(GetParent (hwndDlg),IDC_NETWORK,CB_FINDSTRING,0,(LPARAM)pAbook->szPrefix)!=CB_ERR));
							EnableWindow (GetDlgItem (hwndDlg, IDC_REMOVE), (pAbook->cbEntryID==0));
							break;
						}
						case LVN_COLUMNCLICK:
						{
							static int sortInt = 1;
							sortInt *= -1;

							((LPNMLISTVIEW)lParam)->lParam = sortInt;
							ListView_SortItems(GetDlgItem(hwndDlg, wParam), CompareFunc, lParam);
							break;
						}
					}
					break;
			}
			break;
		case WM_DESTROY:
		{
			int i;
			HWND hNumbers = GetDlgItem(hwndDlg,IDC_NUMBERS);

			// Unload the Address-book structure from memory
			for (i=0; i<ListView_GetItemCount (hNumbers); i++) {
				LVITEM lvi={0};
				ABOOK *pAbook;

				lvi.mask = LVIF_PARAM;
				lvi.iItem = i;
				if (!ListView_GetItem (hNumbers, &lvi)) continue;
				pAbook = (ABOOK*)lvi.lParam;
				free (pAbook->szFirstName);
				free (pAbook->szLastName);
				free (pAbook->szPrefix);
				free (pAbook->szNumber);
				free (pAbook->szDBName);
				free (pAbook);
			}

			// Free the address book if it was used
			if (lpAdrBook) lpAdrBook->lpVtbl->Release(lpAdrBook);
			if (lpWABObject) lpWABObject->lpVtbl->Release(lpWABObject);
			if (hInstLib) FreeLibrary (hInstLib);

			Utils_SaveWindowPosition(hwndDlg, NULL, pszModulename, "ADDRBOOKdlg");
			break;
		}
	}
    return FALSE;
}


static BOOL CALLBACK SendDlgProc(HWND hwndDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	unsigned int i;
	char buf[256];

	switch(message) {
	case WM_INITDIALOG:
		{
			int sel=0;
			DBVARIANT dbv;
			HANDLE hABookIcon = LoadImage (hInst, MAKEINTRESOURCE (IDI_ABOOK), IMAGE_ICON, 16, 16, 0);
			
			TranslateDialogDefault (hwndDlg);
			Utils_RestoreWindowPosition(hwndDlg, NULL, pszModulename, "SMSdlg");
			SetFocus (GetDlgItem (hwndDlg, IDC_NETWORK));
#ifdef _UNICODE
			SendDlgItemMessage (hwndDlg, IDC_MESSAGE, CCM_SETUNICODEFORMAT, 1, 0);
#endif
			if(Gateways->next==NULL) {
				SHOWERROR("There is no Gateway .ini file in the given path, so I cannot send SMS.");
				DestroyWindow(hwndDlg);
				break;
			}
			i=0;
			while (Prefixes[i])
			{
				char *ptr = Prefixes[i]+strlen(Prefixes[i]);
				int j;
				
				*ptr='-';
				j=SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_ADDSTRING,0,(LPARAM)Prefixes[i]);
				*ptr=0;
				SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_SETITEMDATA,j,(LPARAM)Prefixes[i]);
				if (lParam && ((SENDWPARAM*)lParam)->sms && ((SENDWPARAM*)lParam)->sms->prefix && 
					!strcmp(((SENDWPARAM*)lParam)->sms->prefix, Prefixes[i])) sel=j;
				i++;
			}
			if (!lParam && sel==0 && !DBGetContactSetting(NULL, pluginInfo.shortName, "LastSelectedPrefix", &dbv)) {
				if ((sel=SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_FINDSTRING,0,(LPARAM)dbv.pszVal))==CB_ERR) sel=0;
				DBFreeVariant(&dbv);
			}

			SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_SETCURSEL,sel,0);
			SendMessage(hwndDlg,WM_COMMAND, IDC_NETWORK, 0);

			if (lParam) {
				if (((SENDWPARAM*)lParam)->sms) {
					if (((SENDWPARAM*)lParam)->sms->number)
						SetDlgItemText(hwndDlg, IDC_NUMBER, ((SENDWPARAM*)lParam)->sms->number);
					if (((SENDWPARAM*)lParam)->sms->szMsg)
						SetDlgItemText(hwndDlg, IDC_MESSAGE, ((SENDWPARAM*)lParam)->sms->szMsg);
				}
				if (((SENDWPARAM*)lParam)->hContact) {
					stpar.hContact=((SENDWPARAM*)lParam)->hContact;
					stpar.hwndDlg=hwndDlg;
					
					stpar.hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
					if (_beginthread(SendSMSThread, 0, &stpar)!=-1) {
						DEBUG_OUT("DlgProc: Waiting for Miranda to notice our thread.\n");
						WaitForSingleObject(stpar.hEvent, INFINITE);
						DEBUG_OUT("DlgProc: Miranda hopefully found us :)\n");
					}
					CloseHandle(stpar.hEvent);
				}
			}
			CheckDlgButton(hwndDlg, IDC_NUMBER, (BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "NumberMsgs", 0));
			SendDlgEditProc = (WNDPROC) SetWindowLong(GetDlgItem(hwndDlg, IDC_MESSAGE), GWL_WNDPROC, (LONG) SendDlgEditSubclassProc);
			SendDlgItemMessage (hwndDlg, IDC_ADDRSEL, BM_SETIMAGE, IMAGE_ICON, (LPARAM) hABookIcon);
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_NETWORK:
		{
			char *CurrentPrefix;
			int cursel;
			HANDLE hContact;
			char buf[64];

			if ((cursel=SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_GETCURSEL,0,0))==CB_ERR) break;
			CurrentPrefix = (char *)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETITEMDATA, cursel, 0);
			GetDlgItemText (hwndDlg, IDC_NUMBER, buf, sizeof(buf));
			SendDlgItemMessage(hwndDlg,IDC_NUMBER,CB_RESETCONTENT,0,0);
			SetDlgItemText (hwndDlg, IDC_NUMBER, buf);
			for (hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST, 0, 0);hContact != NULL;hContact=(HANDLE)CallService( MS_DB_CONTACT_FINDNEXT, (WPARAM)hContact, 0)) {
				SMSDATA sms = GetPhoneNumber (hContact);

				if (sms.number) {
					if (!strcmp(CurrentPrefix, sms.prefix))
						SendDlgItemMessage(hwndDlg,IDC_NUMBER,CB_ADDSTRING,0,(LPARAM)sms.number);
					FreeSMSData (&sms);
				}
			}
			break;
		}
		case IDSEND:
			{
				GetDlgItemText(hwndDlg, IDC_NUMBER, buf, sizeof(buf));
				if (SendDlgItemMessage(hwndDlg,IDC_NUMBER,CB_FINDSTRING,0,(LPARAM)buf)==CB_ERR) {
					DEBUG_OUT("Writing new Entry to Numbers list.\n");
					add_contact ((char *)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETITEMDATA, SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_GETCURSEL,0,0), 0), buf);
					SendDlgItemMessage(hwndDlg,IDC_NUMBER,CB_ADDSTRING,0,(LPARAM)buf);
				}
				stpar.hContact=NULL;
				stpar.hwndDlg=hwndDlg;
				DEBUG_OUT("Calling SendSMSThread: hContact=%d, hwndDlg=%d\n", stpar.hContact, stpar.hwndDlg);
				stpar.hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
				if (_beginthread(SendSMSThread, 0, &stpar)!=-1) {
					DEBUG_OUT("DlgProc: Waiting for Miranda to notice our thread.\n");
					WaitForSingleObject(stpar.hEvent, INFINITE);
					DEBUG_OUT("DlgProc: Miranda hopefully found us :)\n");
				}
				CloseHandle(stpar.hEvent);
			}
			break;
		case IDCANCEL:
			EnableWindow(GetDlgItem(hwndDlg, IDCANCEL), FALSE);
			if (GetWindowLong(GetDlgItem(hwndDlg, IDSEND), GWL_STYLE)&WS_DISABLED) {
				SetDlgItemText(hwndDlg, IDC_STATUS, "Aborting... (This may take some time)");
				AbortSending=TRUE;
			} else
				EndDialog (hwndDlg, 0);
			break;
		case IDC_MESSAGE:
			{
				char buf[16];

				_snprintf(buf, sizeof(buf), "%d", SendDlgItemMessage(hwndDlg,IDC_MESSAGE,WM_GETTEXTLENGTH,0,0));
				SetDlgItemText(hwndDlg, IDC_COUNTER, buf);
			}
			break;
		case IDC_ADDRSEL:
			DialogBox (hInst,MAKEINTRESOURCE(IDD_ADDRBOOK),hwndDlg,AddrBookDlgProc); 
			SetFocus (GetDlgItem (hwndDlg, IDC_MESSAGE));
			break;
		}
		break;
	case WM_DESTROY:
		if (SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETCOUNT, 0, 0)>0)
			DBWriteContactSettingString(NULL, pluginInfo.shortName, "LastSelectedPrefix", (char *)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETITEMDATA, SendDlgItemMessage(hwndDlg,IDC_NETWORK,CB_GETCURSEL,0,0), 0));
/*
		for (i=0;i<(unsigned int)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETCOUNT, 0, 0);i++)
			free((char *)SendDlgItemMessage(hwndDlg, IDC_NETWORK, CB_GETITEMDATA, i, 0));
*/
		Utils_SaveWindowPosition(hwndDlg, NULL, pszModulename, "SMSdlg");
		break;
	}
	return FALSE;
}

/*******************************************************************************/

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	hInst=hinstDLL;
	return TRUE;
}

__declspec(dllexport) PLUGININFO* MirandaPluginInfo(DWORD mirandaVersion)
{
	return &pluginInfo;
}

// New plugin API
__declspec(dllexport) PLUGININFOEX* MirandaPluginInfoEx(DWORD mirandaVersion)
{
	return &pluginInfoEx;
}

__declspec(dllexport) const MUUID* MirandaPluginInterfaces(void)
{
	return interfaces;
}

int __declspec(dllexport) Load(PLUGINLINK *link)
{
	DBVARIANT dbv={0};
	unsigned int i;
	PROTOCOLDESCRIPTOR pd={0};

	pluginLink=link;

	DEBUG_OUT("[Startup] Starting up WebSMS module...\n");

	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "GatewayPath", &dbv)) {
		DEBUG_OUT("Using path from Database\n");
		CopyMemory(GatewayPath, dbv.pszVal, sizeof(GatewayPath));
		DBFreeVariant(&dbv);
	} else strcpy(GatewayPath, ".\\Gateways");
	SubstitutePath(GatewayPath);

	ListInit();
	if (ScanGatewayList()==-1) return 0;

	hHookModulesLoaded = HookEvent( ME_SYSTEM_MODULESLOADED, Init);
	hOptHook = HookEvent(ME_OPT_INITIALISE, RegisterOptions);
	hStatusModeHook = HookEvent(ME_CLIST_STATUSMODECHANGE,StatusModeChange);
	hPrebuildCMenu = HookEvent(ME_CLIST_PREBUILDCONTACTMENU, PrebuildContactMenu);

	/* Initialize default options */
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "SuccessMsg", &dbv)) DBFreeVariant(&dbv);
	else DBWriteContactSettingString(NULL, pluginInfo.shortName, "SuccessMsg", "Your message has been sent successfully to my owner! :)");
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FailureMsg", &dbv)) DBFreeVariant(&dbv);
	else DBWriteContactSettingString(NULL, pluginInfo.shortName, "FailureMsg", "Sorry, I was not able to send your SMS-Message to my owner.. You may try again later.");
	if (!DBGetContactSetting(NULL, pluginInfo.shortName, "FloodMsg", &dbv)) DBFreeVariant(&dbv);
	else DBWriteContactSettingString(NULL, pluginInfo.shortName, "FloodMsg", "Sorry, you are not allowed to flood me with SMS-messages. Please wait %d minutes, before you can send the next message.");

	/* Convert phone number entries from versions prior to 0.0.0.8 to contacts*/
	for (i=0;i<65535;i++) {
		DBVARIANT dbv, dbv2;
		HANDLE hContact;
		char buf[16], buf2[16];

		_snprintf(buf, sizeof(buf), "LastPrefix%d", i);
		if (!DBGetContactSetting(NULL, pluginInfo.shortName, buf, &dbv)) {
			_snprintf(buf2, sizeof(buf), "LastNumber%d", i);
			if (!DBGetContactSetting(NULL, pluginInfo.shortName, buf2, &dbv2)) {
				// Check if there is already a contact with this prefix + number
				for (hContact=(HANDLE)CallService(MS_DB_CONTACT_FINDFIRST, 0, 0);hContact != NULL;hContact=(HANDLE)CallService( MS_DB_CONTACT_FINDNEXT, (WPARAM)hContact, 0)) {
					SMSDATA sms = GetPhoneNumber (hContact);

					if (sms.number) {
						BOOL bOk=FALSE;

						if (!strcmp (dbv.pszVal, sms.prefix) && !strcmp (dbv2.pszVal, sms.number)) bOk=TRUE;
						FreeSMSData (&sms);
						if (bOk) break;
					}
				}
				if (!hContact && !add_contact (dbv.pszVal, dbv2.pszVal)) {
					DBFreeVariant (&dbv);
					DBFreeVariant (&dbv2);
					continue;
				}
				DBFreeVariant(&dbv2);
				DBDeleteContactSetting (NULL, pluginInfo.shortName, buf2);
			}
			DBFreeVariant(&dbv);
			DBDeleteContactSetting (NULL, pluginInfo.shortName, buf);
		} else if (i) break;
	}

	
	/* Loading WinInet, if you want to use it */
#ifdef USE_WININET
	if (LoadWinInet()==0) UseWinInet=TRUE;
#endif

	DEBUG_OUT("[Startup] OK, complete.\n");
	return 0;
}


int __declspec(dllexport) Unload(void)
{
	DBWriteContactSettingByte(NULL, pluginInfo.shortName, "Active", (BYTE)Activated);
	Netlib_CloseHandle(hNetlibUser);
	UnhookEvent(hHookModulesLoaded);
	UnhookEvent(hOptHook);
	UnhookEvent(hStatusModeHook);
	UnhookEvent(hPrebuildCMenu);
	ListCleanup();
	log_close();
	return 0;
}
