#define _UNICODE

#include <stdio.h>
#include <windows.h>
#include <io.h>
#include <process.h>
#include <commctrl.h>
#include <commdlg.h>
#include <shlobj.h>
#include "resource.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>
#include <time.h>
#include <wab.h>
#include "../headers_c/newpluginapi.h"
#include "../headers_c/m_system.h"
#include "../headers_c/m_clist.h"
#include "../headers_c/m_skin.h"
#include "../headers_c/m_netlib.h"
#include "../headers_c/m_database.h"
#include "../headers_c/m_options.h"
#include "../headers_c/m_langpack.h"
#include "../headers_c/m_protocols.h"
#include "../headers_c/m_protosvc.h"
#include "../headers_c/m_protomod.h"
#include "../headers_c/m_utils.h"
#include "../headers_c/m_contacts.h"
#include "../headers_c/m_userinfo.h"
#include "debug.h"

#define USE_WININET 1	// If you don't like WinInet (bloated), comment this line and
						// NETLIB will be used (which isn't capable of SSL)
#define USEPOPUP 1		// Comment it out to disable usage of popup-plugin
#define OUTPUT log_write
#define MAXCOOKIES 20   // 20 Cookies should be enough
#define MAXCUSTOMV 32
#define SHOWERROR(a) ShowMessage(IDI_SMSERR, a, 1);
#define FAILURE { DEBUG_OUT("FAILED.\n"); return -1; }

// SMS message structure
typedef struct {
	char *prefix;
	char *number;
	char *szMsg;
	char *sender;
} SMSDATA;

typedef struct {
	char *szFirstName;
	char *szLastName;
	char *szPrefix;
	char *szNumber;
	char *szDBName;
	HANDLE hContact;
	ULONG cbEntryID;
	LPENTRYID lpEntryID;
} ABOOK;

// Gateway login data
typedef struct {
	char *username;
	char *password;
} LOGINDATA;

// Variable mapping
typedef struct {
	char *pField;
	char *name;
} VARMAP;

// Table with key und value
typedef struct {
	char *key;
	char *value;
} KEYTABLE;

/*
typedef struct {
	SMSDATA *sms;
	int count;
	LOGINDATA login;
	char *CustomVars[MAXCUSTOMV];
	int numCustomV;
	char *lastRedirectURL;
}PARSEDATA;
*/

// Progress bar (ID and window handle)
typedef struct {
	int PROGRESSBAR;
	HWND hwnd;
} PBARDATA;

typedef struct {
	SMSDATA *sms;		// Values to fill out form
	HANDLE hContact;	// Handle to contact to report succ/failure, NULL=don't
} SENDWPARAM;

typedef struct {
	HANDLE hwndDlg;
	HANDLE hContact;
	HANDLE hEvent;
} SENDTPARAM;

// List of Gateways
struct GWLIST {
	char *filename;
	char *fullpath;
	BOOL bEnabled;
	struct GWLIST *next;
};

#ifndef ListView_SetCheckState
   #define ListView_SetCheckState(hwndLV, i, fCheck) \
      ListView_SetItemState(hwndLV, i, \
      INDEXTOSTATEIMAGEMASK((fCheck)+1), LVIS_STATEIMAGEMASK)
#endif


// ************************** WININET *************************** //
#define SSL_BUF_SIZE 4096

int LoadWinInet(void);
int WinInetGet(NETLIBHTTPREQUEST*);
int _HttpFreeRequestStruct(NETLIBHTTPREQUEST*);
NETLIBHTTPREQUEST* _HTTPtransaction(NETLIBHTTPREQUEST*);

// **************************  UTILS  *************************** //
char* stristr(const char*, const char*);

// **************************  POPUP  *************************** //
int ShowMessage(int, char*, int);