#include "main.h"

extern PLUGININFO pluginInfo;
extern HINSTANCE hInst;

#ifdef USEPOPUP
  #include "../popup/api/m_popup.h"
#endif

/*
 * ShowMessage
 *
 * Shows a popup, if the popup plugin is enabled.
 * mustShow: 1 -> If Popup-Plugin is not available/disabled, show Message
 *                in a Messagewindow
 *                If the Popup-Plugin is enabled, let the message stay on
 *                screen until someone clicks it away.
 *           0 -> If Popup-Plugin is not available/disabled, skip message
 * Returns 0 on success, -1 on failure
 *
 */
int ShowMessage(int iconID, char *lpzText, int mustShow) {
#ifdef USEPOPUP
    POPUPDATAEX pud;

	DEBUG_OUT("Called ShowMessage(%d, %s, %d)...", iconID, lpzText, mustShow);
    if ((BYTE)DBGetContactSettingByte(NULL, pluginInfo.shortName, "ShowNonCriticalPopups", 1)==0) FAILURE
	pud.lchContact = (HANDLE)NULL;
    pud.lchIcon = LoadIcon(hInst, MAKEINTRESOURCE(iconID));
    strncpy(pud.lpzContactName, pluginInfo.shortName, MAX_CONTACTNAME);
    strncpy(pud.lpzText, lpzText, MAX_SECONDLINE);
    pud.colorBack = 0;
    pud.colorText = 0;
    pud.PluginWindowProc = (WNDPROC)NULL;
    pud.PluginData = NULL;
	pud.iSeconds = mustShow==1?-1:0;
	pud.lpzClass = mustShow==1?POPUP_CLASS_WARNING:POPUP_CLASS_DEFAULT;
	pud.skinBack = 0;
    if (PUAddPopUpEx(&pud)<0) {
		if (mustShow==1) MessageBox(NULL,lpzText,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
		DEBUG_OUT("FAILED.\n");
		return -1;
	}
	if (mustShow==1) MessageBeep(-1);
	DEBUG_OUT("OK.\n");
	return 0;
#else
	if (mustShow==1) MessageBox(NULL,lpzText,pluginInfo.shortName, MB_OK | MB_ICONWARNING);
	DEBUG_OUT("OK.\n");
	return -1;
#endif
}
